

-- UUAGC 0.9.36 (src/TrfToCFG.ag)
module TrfToCFG(cfgsSwf,cfgsAbc) where

{-# LINE 8 "src/TrfToCFG.ag" #-}

import Data.ByteString.Lazy(ByteString,pack)
import ByteCode
import CFG
import Data.Word
import qualified Data.Set as Set
import Data.Set(Set)
import qualified Data.Map as Map
import Data.Map(Map)
import Codec.Binary.UTF8.String
{-# LINE 18 "dist/src/sdist.27680/asil-1.2/dist/build/TrfToCFG.hs" #-}

{-# LINE 24 "src/TrfToCFG.ag" #-}

-- | Obtains CFGs of all programs in a Swf file
cfgsSwf :: SwfFile -> Programs
cfgsSwf file = out where
  inh = Inh_SwfFile { guid_Inh_SwfFile = 1 }
  sem = sem_SwfFile file
  syn = wrap_SwfFile sem inh
  out = programs_Syn_SwfFile syn

-- | Obtains CFGs of a programs (only one) in an Abc file
cfgsAbc :: AbcFile -> Programs
cfgsAbc file = out where
  inh = Inh_AbcFile { guid_Inh_AbcFile = 1 }
  sem = sem_AbcFile file
  syn = wrap_AbcFile sem inh
  out = programs_Syn_AbcFile syn
{-# LINE 37 "dist/src/sdist.27680/asil-1.2/dist/build/TrfToCFG.hs" #-}
-- AbcFile -----------------------------------------------------
-- cata
sem_AbcFile :: AbcFile  ->
               T_AbcFile 
sem_AbcFile (AbcFile_File _minorVersion _majorVersion _constantPool _methods _metadatas _instances _classes _scripts _bodies )  =
    (sem_AbcFile_File _minorVersion _majorVersion (sem_PoolInfo _constantPool ) (sem_MethodInfos _methods ) (sem_MetaInfos _metadatas ) (sem_InstanceInfos _instances ) (sem_ClassInfos _classes ) (sem_ScriptInfos _scripts ) (sem_BodyInfos _bodies ) )
-- semantic domain
type T_AbcFile  = Int ->
                  ( Int,Programs)
data Inh_AbcFile  = Inh_AbcFile {guid_Inh_AbcFile :: !(Int)}
data Syn_AbcFile  = Syn_AbcFile {guid_Syn_AbcFile :: !(Int),programs_Syn_AbcFile :: !(Programs)}
wrap_AbcFile :: T_AbcFile  ->
                Inh_AbcFile  ->
                Syn_AbcFile 
wrap_AbcFile sem (Inh_AbcFile _lhsIguid )  =
    (let ( _lhsOguid,_lhsOprograms) | True = sem _lhsIguid 
     in  (Syn_AbcFile _lhsOguid _lhsOprograms ))
sem_AbcFile_File :: Word16 ->
                    Word16 ->
                    T_PoolInfo  ->
                    T_MethodInfos  ->
                    T_MetaInfos  ->
                    T_InstanceInfos  ->
                    T_ClassInfos  ->
                    T_ScriptInfos  ->
                    T_BodyInfos  ->
                    T_AbcFile 
sem_AbcFile_File minorVersion_ majorVersion_ constantPool_ methods_ metadatas_ instances_ classes_ scripts_ bodies_  =
    (\ _lhsIguid ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 69 "src/TrfToCFG.hs" #-}
                 )) of
          { _bodiesOguid | _bodiesOguid `seq` (True) ->
          (case (bodies_ _bodiesOguid ) of
           { ( _bodiesIgraphs,_bodiesIguid) | True ->
               (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                       _bodiesIguid
                       {-# LINE 76 "src/TrfToCFG.hs" #-}
                       )) of
                { _lhsOguid | _lhsOguid `seq` (True) ->
                (case (({-# LINE 48 "src/TrfToCFG.ag" #-}
                        [Program_Program _bodiesIgraphs]
                        {-# LINE 81 "src/TrfToCFG.hs" #-}
                        )) of
                 { _lhsOprograms | _lhsOprograms `seq` (True) ->
                 ( _lhsOguid,_lhsOprograms) }) }) }) }))
-- AbcFlag -----------------------------------------------------
-- cata
sem_AbcFlag :: AbcFlag  ->
               T_AbcFlag 
sem_AbcFlag (AbcFlag_LazyInit )  =
    (sem_AbcFlag_LazyInit )
-- semantic domain
type T_AbcFlag  = ( )
sem_AbcFlag_LazyInit :: T_AbcFlag 
sem_AbcFlag_LazyInit  =
    ( )
-- AbcFlags ----------------------------------------------------
-- cata
sem_AbcFlags :: AbcFlags  ->
                T_AbcFlags 
sem_AbcFlags list  =
    (Prelude.foldr sem_AbcFlags_Cons sem_AbcFlags_Nil (Prelude.map sem_AbcFlag list) )
-- semantic domain
type T_AbcFlags  = ( )
sem_AbcFlags_Cons :: T_AbcFlag  ->
                     T_AbcFlags  ->
                     T_AbcFlags 
sem_AbcFlags_Cons hd_ tl_  =
    ( )
sem_AbcFlags_Nil :: T_AbcFlags 
sem_AbcFlags_Nil  =
    ( )
-- BodyInfo ----------------------------------------------------
-- cata
sem_BodyInfo :: BodyInfo  ->
                T_BodyInfo 
sem_BodyInfo (BodyInfo_Info _method _maxStack _localCount _initScopeDepth _maxScopeDepth _instructions _exceptions _traits )  =
    (sem_BodyInfo_Info _method _maxStack _localCount _initScopeDepth _maxScopeDepth (sem_Instructions _instructions ) (sem_Exceptions _exceptions ) (sem_Traits _traits ) )
-- semantic domain
type T_BodyInfo  = Int ->
                   ( CFGs,Int)
sem_BodyInfo_Info :: Word32 ->
                     Word32 ->
                     Word32 ->
                     Word32 ->
                     Word32 ->
                     T_Instructions  ->
                     T_Exceptions  ->
                     T_Traits  ->
                     T_BodyInfo 
sem_BodyInfo_Info method_ maxStack_ localCount_ initScopeDepth_ maxScopeDepth_ instructions_ exceptions_ traits_  =
    (\ _lhsIguid ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 134 "src/TrfToCFG.hs" #-}
                 )) of
          { _instructionsOguid | _instructionsOguid `seq` (True) ->
          (case (({-# LINE 2 "src/ByteCodeLocationInfo.ag" #-}
                  0
                  {-# LINE 139 "src/TrfToCFG.hs" #-}
                  )) of
           { _instructionsOlocation | _instructionsOlocation `seq` (True) ->
           (case (instructions_ _instructionsOguid _instructionsOlocation ) of
            { ( _instructionsIguid,_instructionsIlocation,instructions_1) | True ->
                (case (({-# LINE 3 "src/ByteCodeLocationInfo.ag" #-}
                        0
                        {-# LINE 146 "src/TrfToCFG.hs" #-}
                        )) of
                 { _instructionsOrevLocation | _instructionsOrevLocation `seq` (True) ->
                 (case (instructions_1 _instructionsOrevLocation ) of
                  { ( _instructionsIgraphs,_instructionsIrevLocation) | True ->
                      (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                              _instructionsIgraphs
                              {-# LINE 153 "src/TrfToCFG.hs" #-}
                              )) of
                       { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                       (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                               _instructionsIguid
                               {-# LINE 158 "src/TrfToCFG.hs" #-}
                               )) of
                        { _lhsOguid | _lhsOguid `seq` (True) ->
                        ( _lhsOgraphs,_lhsOguid) }) }) }) }) }) }) }))
-- BodyInfos ---------------------------------------------------
-- cata
sem_BodyInfos :: BodyInfos  ->
                 T_BodyInfos 
sem_BodyInfos list  =
    (Prelude.foldr sem_BodyInfos_Cons sem_BodyInfos_Nil (Prelude.map sem_BodyInfo list) )
-- semantic domain
type T_BodyInfos  = Int ->
                    ( CFGs,Int)
sem_BodyInfos_Cons :: T_BodyInfo  ->
                      T_BodyInfos  ->
                      T_BodyInfos 
sem_BodyInfos_Cons hd_ tl_  =
    (\ _lhsIguid ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 178 "src/TrfToCFG.hs" #-}
                 )) of
          { _hdOguid | _hdOguid `seq` (True) ->
          (case (hd_ _hdOguid ) of
           { ( _hdIgraphs,_hdIguid) | True ->
               (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                       _hdIguid
                       {-# LINE 185 "src/TrfToCFG.hs" #-}
                       )) of
                { _tlOguid | _tlOguid `seq` (True) ->
                (case (tl_ _tlOguid ) of
                 { ( _tlIgraphs,_tlIguid) | True ->
                     (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                             _hdIgraphs ++ _tlIgraphs
                             {-# LINE 192 "src/TrfToCFG.hs" #-}
                             )) of
                      { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                      (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                              _tlIguid
                              {-# LINE 197 "src/TrfToCFG.hs" #-}
                              )) of
                       { _lhsOguid | _lhsOguid `seq` (True) ->
                       ( _lhsOgraphs,_lhsOguid) }) }) }) }) }) }))
sem_BodyInfos_Nil :: T_BodyInfos 
sem_BodyInfos_Nil  =
    (\ _lhsIguid ->
         (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                 []
                 {-# LINE 206 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
          (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                  _lhsIguid
                  {-# LINE 211 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOguid | _lhsOguid `seq` (True) ->
           ( _lhsOgraphs,_lhsOguid) }) }))
-- CaseOffsets -------------------------------------------------
-- cata
sem_CaseOffsets :: CaseOffsets  ->
                   T_CaseOffsets 
sem_CaseOffsets list  =
    (Prelude.foldr sem_CaseOffsets_Cons sem_CaseOffsets_Nil list )
-- semantic domain
type T_CaseOffsets  = Int ->
                      ( Int,T_CaseOffsets_1 )
type T_CaseOffsets_1  = Int ->
                        ( Int)
sem_CaseOffsets_Cons :: Word32 ->
                        T_CaseOffsets  ->
                        T_CaseOffsets 
sem_CaseOffsets_Cons hd_ tl_  =
    (\ _lhsIlocation ->
         (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                 _lhsIlocation
                 {-# LINE 233 "src/TrfToCFG.hs" #-}
                 )) of
          { _tlOlocation | _tlOlocation `seq` (True) ->
          (case (tl_ _tlOlocation ) of
           { ( _tlIlocation,tl_1) | True ->
               (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                       _tlIlocation
                       {-# LINE 240 "src/TrfToCFG.hs" #-}
                       )) of
                { _lhsOlocation | _lhsOlocation `seq` (True) ->
                (case ((let sem_CaseOffsets_Cons_1 :: T_CaseOffsets_1 
                            sem_CaseOffsets_Cons_1  =
                                (\ _lhsIrevLocation ->
                                     (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                             _lhsIrevLocation
                                             {-# LINE 248 "src/TrfToCFG.hs" #-}
                                             )) of
                                      { _tlOrevLocation | _tlOrevLocation `seq` (True) ->
                                      (case (tl_1 _tlOrevLocation ) of
                                       { ( _tlIrevLocation) | True ->
                                           (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                                   _tlIrevLocation
                                                   {-# LINE 255 "src/TrfToCFG.hs" #-}
                                                   )) of
                                            { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                            ( _lhsOrevLocation) }) }) }))
                        in  sem_CaseOffsets_Cons_1)) of
                 { ( sem_CaseOffsets_1) | True ->
                 ( _lhsOlocation,sem_CaseOffsets_1) }) }) }) }))
sem_CaseOffsets_Nil :: T_CaseOffsets 
sem_CaseOffsets_Nil  =
    (\ _lhsIlocation ->
         (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                 _lhsIlocation
                 {-# LINE 267 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOlocation | _lhsOlocation `seq` (True) ->
          (case ((let sem_CaseOffsets_Nil_1 :: T_CaseOffsets_1 
                      sem_CaseOffsets_Nil_1  =
                          (\ _lhsIrevLocation ->
                               (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                       _lhsIrevLocation
                                       {-# LINE 275 "src/TrfToCFG.hs" #-}
                                       )) of
                                { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                ( _lhsOrevLocation) }))
                  in  sem_CaseOffsets_Nil_1)) of
           { ( sem_CaseOffsets_1) | True ->
           ( _lhsOlocation,sem_CaseOffsets_1) }) }))
-- ClassInfo ---------------------------------------------------
-- cata
sem_ClassInfo :: ClassInfo  ->
                 T_ClassInfo 
sem_ClassInfo (ClassInfo_Info _con _traits )  =
    (sem_ClassInfo_Info _con (sem_Traits _traits ) )
-- semantic domain
type T_ClassInfo  = ( )
sem_ClassInfo_Info :: Word32 ->
                      T_Traits  ->
                      T_ClassInfo 
sem_ClassInfo_Info con_ traits_  =
    ( )
-- ClassInfos --------------------------------------------------
-- cata
sem_ClassInfos :: ClassInfos  ->
                  T_ClassInfos 
sem_ClassInfos list  =
    (Prelude.foldr sem_ClassInfos_Cons sem_ClassInfos_Nil (Prelude.map sem_ClassInfo list) )
-- semantic domain
type T_ClassInfos  = ( )
sem_ClassInfos_Cons :: T_ClassInfo  ->
                       T_ClassInfos  ->
                       T_ClassInfos 
sem_ClassInfos_Cons hd_ tl_  =
    ( )
sem_ClassInfos_Nil :: T_ClassInfos 
sem_ClassInfos_Nil  =
    ( )
-- DebugType ---------------------------------------------------
-- cata
sem_DebugType :: DebugType  ->
                 T_DebugType 
sem_DebugType (DebugType_Local )  =
    (sem_DebugType_Local )
-- semantic domain
type T_DebugType  = ( )
sem_DebugType_Local :: T_DebugType 
sem_DebugType_Local  =
    ( )
-- Exception ---------------------------------------------------
-- cata
sem_Exception :: Exception  ->
                 T_Exception 
sem_Exception (Exception_Info _from _to _target _tp _name )  =
    (sem_Exception_Info _from _to _target _tp _name )
-- semantic domain
type T_Exception  = ( )
sem_Exception_Info :: Word32 ->
                      Word32 ->
                      Word32 ->
                      Word32 ->
                      Word32 ->
                      T_Exception 
sem_Exception_Info from_ to_ target_ tp_ name_  =
    ( )
-- Exceptions --------------------------------------------------
-- cata
sem_Exceptions :: Exceptions  ->
                  T_Exceptions 
sem_Exceptions list  =
    (Prelude.foldr sem_Exceptions_Cons sem_Exceptions_Nil (Prelude.map sem_Exception list) )
-- semantic domain
type T_Exceptions  = ( )
sem_Exceptions_Cons :: T_Exception  ->
                       T_Exceptions  ->
                       T_Exceptions 
sem_Exceptions_Cons hd_ tl_  =
    ( )
sem_Exceptions_Nil :: T_Exceptions 
sem_Exceptions_Nil  =
    ( )
-- InstanceFlag ------------------------------------------------
-- cata
sem_InstanceFlag :: InstanceFlag  ->
                    T_InstanceFlag 
sem_InstanceFlag (InstanceFlag_ClassFinal )  =
    (sem_InstanceFlag_ClassFinal )
sem_InstanceFlag (InstanceFlag_ClassInterface )  =
    (sem_InstanceFlag_ClassInterface )
sem_InstanceFlag (InstanceFlag_ClassProtected )  =
    (sem_InstanceFlag_ClassProtected )
sem_InstanceFlag (InstanceFlag_ClassSealed )  =
    (sem_InstanceFlag_ClassSealed )
-- semantic domain
type T_InstanceFlag  = ( )
sem_InstanceFlag_ClassFinal :: T_InstanceFlag 
sem_InstanceFlag_ClassFinal  =
    ( )
sem_InstanceFlag_ClassInterface :: T_InstanceFlag 
sem_InstanceFlag_ClassInterface  =
    ( )
sem_InstanceFlag_ClassProtected :: T_InstanceFlag 
sem_InstanceFlag_ClassProtected  =
    ( )
sem_InstanceFlag_ClassSealed :: T_InstanceFlag 
sem_InstanceFlag_ClassSealed  =
    ( )
-- InstanceFlags -----------------------------------------------
-- cata
sem_InstanceFlags :: InstanceFlags  ->
                     T_InstanceFlags 
sem_InstanceFlags list  =
    (Prelude.foldr sem_InstanceFlags_Cons sem_InstanceFlags_Nil (Prelude.map sem_InstanceFlag list) )
-- semantic domain
type T_InstanceFlags  = ( )
sem_InstanceFlags_Cons :: T_InstanceFlag  ->
                          T_InstanceFlags  ->
                          T_InstanceFlags 
sem_InstanceFlags_Cons hd_ tl_  =
    ( )
sem_InstanceFlags_Nil :: T_InstanceFlags 
sem_InstanceFlags_Nil  =
    ( )
-- InstanceInfo ------------------------------------------------
-- cata
sem_InstanceInfo :: InstanceInfo  ->
                    T_InstanceInfo 
sem_InstanceInfo (InstanceInfo_Info _name _super _flags _protectedNs _interfaces _constructor _traits )  =
    (sem_InstanceInfo_Info _name _super (sem_InstanceFlags _flags ) _protectedNs (sem_Interfaces _interfaces ) _constructor (sem_Traits _traits ) )
-- semantic domain
type T_InstanceInfo  = ( )
sem_InstanceInfo_Info :: Word32 ->
                         Word32 ->
                         T_InstanceFlags  ->
                         Word32 ->
                         T_Interfaces  ->
                         Word32 ->
                         T_Traits  ->
                         T_InstanceInfo 
sem_InstanceInfo_Info name_ super_ flags_ protectedNs_ interfaces_ constructor_ traits_  =
    ( )
-- InstanceInfos -----------------------------------------------
-- cata
sem_InstanceInfos :: InstanceInfos  ->
                     T_InstanceInfos 
sem_InstanceInfos list  =
    (Prelude.foldr sem_InstanceInfos_Cons sem_InstanceInfos_Nil (Prelude.map sem_InstanceInfo list) )
-- semantic domain
type T_InstanceInfos  = ( )
sem_InstanceInfos_Cons :: T_InstanceInfo  ->
                          T_InstanceInfos  ->
                          T_InstanceInfos 
sem_InstanceInfos_Cons hd_ tl_  =
    ( )
sem_InstanceInfos_Nil :: T_InstanceInfos 
sem_InstanceInfos_Nil  =
    ( )
-- Instruction -------------------------------------------------
-- cata
sem_Instruction :: Instruction  ->
                   T_Instruction 
sem_Instruction (Instruction_Add )  =
    (sem_Instruction_Add )
sem_Instruction (Instruction_Add_d )  =
    (sem_Instruction_Add_d )
sem_Instruction (Instruction_Add_i )  =
    (sem_Instruction_Add_i )
sem_Instruction (Instruction_ApplyType _name )  =
    (sem_Instruction_ApplyType _name )
sem_Instruction (Instruction_AsType _name )  =
    (sem_Instruction_AsType _name )
sem_Instruction (Instruction_AsTypeLate )  =
    (sem_Instruction_AsTypeLate )
sem_Instruction (Instruction_BitAnd )  =
    (sem_Instruction_BitAnd )
sem_Instruction (Instruction_BitNot )  =
    (sem_Instruction_BitNot )
sem_Instruction (Instruction_BitOr )  =
    (sem_Instruction_BitOr )
sem_Instruction (Instruction_BitXor )  =
    (sem_Instruction_BitXor )
sem_Instruction (Instruction_BreakLine _line )  =
    (sem_Instruction_BreakLine _line )
sem_Instruction (Instruction_Breakpoint )  =
    (sem_Instruction_Breakpoint )
sem_Instruction (Instruction_Call _argCount )  =
    (sem_Instruction_Call _argCount )
sem_Instruction (Instruction_CallInterface _name _argCount )  =
    (sem_Instruction_CallInterface _name _argCount )
sem_Instruction (Instruction_CallMethod _index _argCount )  =
    (sem_Instruction_CallMethod _index _argCount )
sem_Instruction (Instruction_CallProp _name _argCount )  =
    (sem_Instruction_CallProp _name _argCount )
sem_Instruction (Instruction_CallPropLex _name _argCount )  =
    (sem_Instruction_CallPropLex _name _argCount )
sem_Instruction (Instruction_CallPropVoid _name _argCount )  =
    (sem_Instruction_CallPropVoid _name _argCount )
sem_Instruction (Instruction_CallStatic _method _argCount )  =
    (sem_Instruction_CallStatic _method _argCount )
sem_Instruction (Instruction_CallSuper _name _argCount )  =
    (sem_Instruction_CallSuper _name _argCount )
sem_Instruction (Instruction_CallSuperId )  =
    (sem_Instruction_CallSuperId )
sem_Instruction (Instruction_CallSuperVoid _name _argCount )  =
    (sem_Instruction_CallSuperVoid _name _argCount )
sem_Instruction (Instruction_CheckFilter )  =
    (sem_Instruction_CheckFilter )
sem_Instruction (Instruction_Coerce _name )  =
    (sem_Instruction_Coerce _name )
sem_Instruction (Instruction_Coerce_a )  =
    (sem_Instruction_Coerce_a )
sem_Instruction (Instruction_Coerce_b )  =
    (sem_Instruction_Coerce_b )
sem_Instruction (Instruction_Coerce_d )  =
    (sem_Instruction_Coerce_d )
sem_Instruction (Instruction_Coerce_i )  =
    (sem_Instruction_Coerce_i )
sem_Instruction (Instruction_Coerce_o )  =
    (sem_Instruction_Coerce_o )
sem_Instruction (Instruction_Coerce_s )  =
    (sem_Instruction_Coerce_s )
sem_Instruction (Instruction_Coerce_u )  =
    (sem_Instruction_Coerce_u )
sem_Instruction (Instruction_Concat )  =
    (sem_Instruction_Concat )
sem_Instruction (Instruction_Construct _argCount )  =
    (sem_Instruction_Construct _argCount )
sem_Instruction (Instruction_ConstructProp _name _argCount )  =
    (sem_Instruction_ConstructProp _name _argCount )
sem_Instruction (Instruction_ConstructSuper _argCount )  =
    (sem_Instruction_ConstructSuper _argCount )
sem_Instruction (Instruction_Convert_b )  =
    (sem_Instruction_Convert_b )
sem_Instruction (Instruction_Convert_d )  =
    (sem_Instruction_Convert_d )
sem_Instruction (Instruction_Convert_i )  =
    (sem_Instruction_Convert_i )
sem_Instruction (Instruction_Convert_o )  =
    (sem_Instruction_Convert_o )
sem_Instruction (Instruction_Convert_s )  =
    (sem_Instruction_Convert_s )
sem_Instruction (Instruction_Convert_u )  =
    (sem_Instruction_Convert_u )
sem_Instruction (Instruction_Debug _tp _name _reg _extra )  =
    (sem_Instruction_Debug (sem_DebugType _tp ) _name _reg _extra )
sem_Instruction (Instruction_DebugFile _name )  =
    (sem_Instruction_DebugFile _name )
sem_Instruction (Instruction_DebugLine _line )  =
    (sem_Instruction_DebugLine _line )
sem_Instruction (Instruction_DecLocal _reg )  =
    (sem_Instruction_DecLocal _reg )
sem_Instruction (Instruction_DecLocal_i _reg )  =
    (sem_Instruction_DecLocal_i _reg )
sem_Instruction (Instruction_Decrement )  =
    (sem_Instruction_Decrement )
sem_Instruction (Instruction_Decrement_i )  =
    (sem_Instruction_Decrement_i )
sem_Instruction (Instruction_DeleteProperty _name )  =
    (sem_Instruction_DeleteProperty _name )
sem_Instruction (Instruction_DeletePropertyLate )  =
    (sem_Instruction_DeletePropertyLate )
sem_Instruction (Instruction_Divide )  =
    (sem_Instruction_Divide )
sem_Instruction (Instruction_Dup )  =
    (sem_Instruction_Dup )
sem_Instruction (Instruction_Dxns _name )  =
    (sem_Instruction_Dxns _name )
sem_Instruction (Instruction_DxnsLate )  =
    (sem_Instruction_DxnsLate )
sem_Instruction (Instruction_Equals )  =
    (sem_Instruction_Equals )
sem_Instruction (Instruction_EscXAttr )  =
    (sem_Instruction_EscXAttr )
sem_Instruction (Instruction_EscXElem )  =
    (sem_Instruction_EscXElem )
sem_Instruction (Instruction_FindDef _name )  =
    (sem_Instruction_FindDef _name )
sem_Instruction (Instruction_FindPropStrict _name )  =
    (sem_Instruction_FindPropStrict _name )
sem_Instruction (Instruction_FindProperty _name )  =
    (sem_Instruction_FindProperty _name )
sem_Instruction (Instruction_FindPropertyGlobal _name )  =
    (sem_Instruction_FindPropertyGlobal _name )
sem_Instruction (Instruction_FindPropertyGlobalStrict _name )  =
    (sem_Instruction_FindPropertyGlobalStrict _name )
sem_Instruction (Instruction_GetDescendants _name )  =
    (sem_Instruction_GetDescendants _name )
sem_Instruction (Instruction_GetGlobalScope )  =
    (sem_Instruction_GetGlobalScope )
sem_Instruction (Instruction_GetGlobalSlot _slot )  =
    (sem_Instruction_GetGlobalSlot _slot )
sem_Instruction (Instruction_GetLex _name )  =
    (sem_Instruction_GetLex _name )
sem_Instruction (Instruction_GetLocal _reg )  =
    (sem_Instruction_GetLocal _reg )
sem_Instruction (Instruction_GetLocal0 )  =
    (sem_Instruction_GetLocal0 )
sem_Instruction (Instruction_GetLocal1 )  =
    (sem_Instruction_GetLocal1 )
sem_Instruction (Instruction_GetLocal2 )  =
    (sem_Instruction_GetLocal2 )
sem_Instruction (Instruction_GetLocal3 )  =
    (sem_Instruction_GetLocal3 )
sem_Instruction (Instruction_GetOuterScope _name )  =
    (sem_Instruction_GetOuterScope _name )
sem_Instruction (Instruction_GetProperty _name )  =
    (sem_Instruction_GetProperty _name )
sem_Instruction (Instruction_GetScopeObject _index )  =
    (sem_Instruction_GetScopeObject _index )
sem_Instruction (Instruction_GetSlot _slot )  =
    (sem_Instruction_GetSlot _slot )
sem_Instruction (Instruction_GetSuper _name )  =
    (sem_Instruction_GetSuper _name )
sem_Instruction (Instruction_GreaterEquals )  =
    (sem_Instruction_GreaterEquals )
sem_Instruction (Instruction_GreaterThan )  =
    (sem_Instruction_GreaterThan )
sem_Instruction (Instruction_HasNext )  =
    (sem_Instruction_HasNext )
sem_Instruction (Instruction_HasNext2 _objectReg _indexReg )  =
    (sem_Instruction_HasNext2 _objectReg _indexReg )
sem_Instruction (Instruction_IfEq _offset )  =
    (sem_Instruction_IfEq _offset )
sem_Instruction (Instruction_IfFalse _offset )  =
    (sem_Instruction_IfFalse _offset )
sem_Instruction (Instruction_IfGe _offset )  =
    (sem_Instruction_IfGe _offset )
sem_Instruction (Instruction_IfGt _offset )  =
    (sem_Instruction_IfGt _offset )
sem_Instruction (Instruction_IfLe _offset )  =
    (sem_Instruction_IfLe _offset )
sem_Instruction (Instruction_IfLt _offset )  =
    (sem_Instruction_IfLt _offset )
sem_Instruction (Instruction_IfNGe _offset )  =
    (sem_Instruction_IfNGe _offset )
sem_Instruction (Instruction_IfNGt _offset )  =
    (sem_Instruction_IfNGt _offset )
sem_Instruction (Instruction_IfNLe _offset )  =
    (sem_Instruction_IfNLe _offset )
sem_Instruction (Instruction_IfNLt _offset )  =
    (sem_Instruction_IfNLt _offset )
sem_Instruction (Instruction_IfNe _offset )  =
    (sem_Instruction_IfNe _offset )
sem_Instruction (Instruction_IfStrictEq _offset )  =
    (sem_Instruction_IfStrictEq _offset )
sem_Instruction (Instruction_IfStrictNe _offset )  =
    (sem_Instruction_IfStrictNe _offset )
sem_Instruction (Instruction_IfTrue _offset )  =
    (sem_Instruction_IfTrue _offset )
sem_Instruction (Instruction_In )  =
    (sem_Instruction_In )
sem_Instruction (Instruction_IncLocal _reg )  =
    (sem_Instruction_IncLocal _reg )
sem_Instruction (Instruction_IncLocal_i _reg )  =
    (sem_Instruction_IncLocal_i _reg )
sem_Instruction (Instruction_Increment )  =
    (sem_Instruction_Increment )
sem_Instruction (Instruction_Increment_i )  =
    (sem_Instruction_Increment_i )
sem_Instruction (Instruction_InitProperty _name )  =
    (sem_Instruction_InitProperty _name )
sem_Instruction (Instruction_InstanceOf )  =
    (sem_Instruction_InstanceOf )
sem_Instruction (Instruction_IsType _name )  =
    (sem_Instruction_IsType _name )
sem_Instruction (Instruction_IsTypeLate )  =
    (sem_Instruction_IsTypeLate )
sem_Instruction (Instruction_Jump _offset )  =
    (sem_Instruction_Jump _offset )
sem_Instruction (Instruction_Kill _reg )  =
    (sem_Instruction_Kill _reg )
sem_Instruction (Instruction_Label )  =
    (sem_Instruction_Label )
sem_Instruction (Instruction_LessEquals )  =
    (sem_Instruction_LessEquals )
sem_Instruction (Instruction_LessThan )  =
    (sem_Instruction_LessThan )
sem_Instruction (Instruction_LoadFloat32 )  =
    (sem_Instruction_LoadFloat32 )
sem_Instruction (Instruction_LoadFloat64 )  =
    (sem_Instruction_LoadFloat64 )
sem_Instruction (Instruction_LoadIndirect16 )  =
    (sem_Instruction_LoadIndirect16 )
sem_Instruction (Instruction_LoadIndirect32 )  =
    (sem_Instruction_LoadIndirect32 )
sem_Instruction (Instruction_LoadIndirect8 )  =
    (sem_Instruction_LoadIndirect8 )
sem_Instruction (Instruction_Location _index )  =
    (sem_Instruction_Location _index )
sem_Instruction (Instruction_LookupSwitch _defaultOffset _caseOffsets )  =
    (sem_Instruction_LookupSwitch _defaultOffset (sem_CaseOffsets _caseOffsets ) )
sem_Instruction (Instruction_Lshift )  =
    (sem_Instruction_Lshift )
sem_Instruction (Instruction_Modulo )  =
    (sem_Instruction_Modulo )
sem_Instruction (Instruction_Multiply )  =
    (sem_Instruction_Multiply )
sem_Instruction (Instruction_Multiply_i )  =
    (sem_Instruction_Multiply_i )
sem_Instruction (Instruction_Negate )  =
    (sem_Instruction_Negate )
sem_Instruction (Instruction_Negate_i )  =
    (sem_Instruction_Negate_i )
sem_Instruction (Instruction_NewActivation )  =
    (sem_Instruction_NewActivation )
sem_Instruction (Instruction_NewArray _argCount )  =
    (sem_Instruction_NewArray _argCount )
sem_Instruction (Instruction_NewCatch _exception )  =
    (sem_Instruction_NewCatch _exception )
sem_Instruction (Instruction_NewClass _class )  =
    (sem_Instruction_NewClass _class )
sem_Instruction (Instruction_NewFunction _method )  =
    (sem_Instruction_NewFunction _method )
sem_Instruction (Instruction_NewObject _argCount )  =
    (sem_Instruction_NewObject _argCount )
sem_Instruction (Instruction_NextName )  =
    (sem_Instruction_NextName )
sem_Instruction (Instruction_NextValue )  =
    (sem_Instruction_NextValue )
sem_Instruction (Instruction_Nop )  =
    (sem_Instruction_Nop )
sem_Instruction (Instruction_Not )  =
    (sem_Instruction_Not )
sem_Instruction (Instruction_Pop )  =
    (sem_Instruction_Pop )
sem_Instruction (Instruction_PopScope )  =
    (sem_Instruction_PopScope )
sem_Instruction (Instruction_PushByte _val )  =
    (sem_Instruction_PushByte _val )
sem_Instruction (Instruction_PushDouble _name )  =
    (sem_Instruction_PushDouble _name )
sem_Instruction (Instruction_PushFalse )  =
    (sem_Instruction_PushFalse )
sem_Instruction (Instruction_PushInt _name )  =
    (sem_Instruction_PushInt _name )
sem_Instruction (Instruction_PushNaN )  =
    (sem_Instruction_PushNaN )
sem_Instruction (Instruction_PushNamespace _name )  =
    (sem_Instruction_PushNamespace _name )
sem_Instruction (Instruction_PushNull )  =
    (sem_Instruction_PushNull )
sem_Instruction (Instruction_PushScope )  =
    (sem_Instruction_PushScope )
sem_Instruction (Instruction_PushShort _val )  =
    (sem_Instruction_PushShort _val )
sem_Instruction (Instruction_PushString _name )  =
    (sem_Instruction_PushString _name )
sem_Instruction (Instruction_PushTrue )  =
    (sem_Instruction_PushTrue )
sem_Instruction (Instruction_PushUInt _name )  =
    (sem_Instruction_PushUInt _name )
sem_Instruction (Instruction_PushUndefined )  =
    (sem_Instruction_PushUndefined )
sem_Instruction (Instruction_PushWith )  =
    (sem_Instruction_PushWith )
sem_Instruction (Instruction_ReturnValue )  =
    (sem_Instruction_ReturnValue )
sem_Instruction (Instruction_ReturnVoid )  =
    (sem_Instruction_ReturnVoid )
sem_Instruction (Instruction_Rshift )  =
    (sem_Instruction_Rshift )
sem_Instruction (Instruction_SetGlobalSlot _slot )  =
    (sem_Instruction_SetGlobalSlot _slot )
sem_Instruction (Instruction_SetLocal _reg )  =
    (sem_Instruction_SetLocal _reg )
sem_Instruction (Instruction_SetLocal0 )  =
    (sem_Instruction_SetLocal0 )
sem_Instruction (Instruction_SetLocal1 )  =
    (sem_Instruction_SetLocal1 )
sem_Instruction (Instruction_SetLocal2 )  =
    (sem_Instruction_SetLocal2 )
sem_Instruction (Instruction_SetLocal3 )  =
    (sem_Instruction_SetLocal3 )
sem_Instruction (Instruction_SetProperty _name )  =
    (sem_Instruction_SetProperty _name )
sem_Instruction (Instruction_SetPropertyLate )  =
    (sem_Instruction_SetPropertyLate )
sem_Instruction (Instruction_SetSlot _slot )  =
    (sem_Instruction_SetSlot _slot )
sem_Instruction (Instruction_SetSuper _name )  =
    (sem_Instruction_SetSuper _name )
sem_Instruction (Instruction_SignExtend1 )  =
    (sem_Instruction_SignExtend1 )
sem_Instruction (Instruction_SignExtend16 )  =
    (sem_Instruction_SignExtend16 )
sem_Instruction (Instruction_SignExtend8 )  =
    (sem_Instruction_SignExtend8 )
sem_Instruction (Instruction_StoreFloat32 )  =
    (sem_Instruction_StoreFloat32 )
sem_Instruction (Instruction_StoreFloat64 )  =
    (sem_Instruction_StoreFloat64 )
sem_Instruction (Instruction_StoreIndirect16 )  =
    (sem_Instruction_StoreIndirect16 )
sem_Instruction (Instruction_StoreIndirect32 )  =
    (sem_Instruction_StoreIndirect32 )
sem_Instruction (Instruction_StoreIndirect8 )  =
    (sem_Instruction_StoreIndirect8 )
sem_Instruction (Instruction_StrictEquals )  =
    (sem_Instruction_StrictEquals )
sem_Instruction (Instruction_Substract )  =
    (sem_Instruction_Substract )
sem_Instruction (Instruction_Substract_i )  =
    (sem_Instruction_Substract_i )
sem_Instruction (Instruction_Swap )  =
    (sem_Instruction_Swap )
sem_Instruction (Instruction_Throw )  =
    (sem_Instruction_Throw )
sem_Instruction (Instruction_Timestamp )  =
    (sem_Instruction_Timestamp )
sem_Instruction (Instruction_TypeOf )  =
    (sem_Instruction_TypeOf )
sem_Instruction (Instruction_Urshift )  =
    (sem_Instruction_Urshift )
-- semantic domain
type T_Instruction  = Int ->
                      Int ->
                      ( Int,Int,T_Instruction_1 )
type T_Instruction_1  = Int ->
                        ( CFGs,Int)
sem_Instruction_Add :: T_Instruction 
sem_Instruction_Add  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 798 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 803 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_Add_1 :: T_Instruction_1 
                       sem_Instruction_Add_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 811 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 816 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_Add_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_Add_d :: T_Instruction 
sem_Instruction_Add_d  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 829 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 834 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_Add_d_1 :: T_Instruction_1 
                       sem_Instruction_Add_d_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 842 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 847 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_Add_d_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_Add_i :: T_Instruction 
sem_Instruction_Add_i  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 860 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 865 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_Add_i_1 :: T_Instruction_1 
                       sem_Instruction_Add_i_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 873 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 878 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_Add_i_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_ApplyType :: Word32 ->
                             T_Instruction 
sem_Instruction_ApplyType name_  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 892 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 897 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_ApplyType_1 :: T_Instruction_1 
                       sem_Instruction_ApplyType_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 905 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 910 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_ApplyType_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_AsType :: Word32 ->
                          T_Instruction 
sem_Instruction_AsType name_  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 924 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 929 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_AsType_1 :: T_Instruction_1 
                       sem_Instruction_AsType_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 937 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 942 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_AsType_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_AsTypeLate :: T_Instruction 
sem_Instruction_AsTypeLate  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 955 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 960 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_AsTypeLate_1 :: T_Instruction_1 
                       sem_Instruction_AsTypeLate_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 968 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 973 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_AsTypeLate_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_BitAnd :: T_Instruction 
sem_Instruction_BitAnd  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 986 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 991 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_BitAnd_1 :: T_Instruction_1 
                       sem_Instruction_BitAnd_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 999 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 1004 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_BitAnd_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_BitNot :: T_Instruction 
sem_Instruction_BitNot  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 1017 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 1022 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_BitNot_1 :: T_Instruction_1 
                       sem_Instruction_BitNot_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 1030 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 1035 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_BitNot_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_BitOr :: T_Instruction 
sem_Instruction_BitOr  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 1048 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 1053 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_BitOr_1 :: T_Instruction_1 
                       sem_Instruction_BitOr_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 1061 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 1066 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_BitOr_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_BitXor :: T_Instruction 
sem_Instruction_BitXor  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 1079 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 1084 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_BitXor_1 :: T_Instruction_1 
                       sem_Instruction_BitXor_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 1092 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 1097 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_BitXor_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_BreakLine :: Word32 ->
                             T_Instruction 
sem_Instruction_BreakLine line_  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 1111 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 1116 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_BreakLine_1 :: T_Instruction_1 
                       sem_Instruction_BreakLine_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 1124 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 1129 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_BreakLine_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_Breakpoint :: T_Instruction 
sem_Instruction_Breakpoint  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 1142 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 1147 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_Breakpoint_1 :: T_Instruction_1 
                       sem_Instruction_Breakpoint_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 1155 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 1160 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_Breakpoint_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_Call :: Word32 ->
                        T_Instruction 
sem_Instruction_Call argCount_  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 1174 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 1179 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_Call_1 :: T_Instruction_1 
                       sem_Instruction_Call_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 1187 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 1192 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_Call_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_CallInterface :: Word32 ->
                                 Word32 ->
                                 T_Instruction 
sem_Instruction_CallInterface name_ argCount_  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 1207 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 1212 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_CallInterface_1 :: T_Instruction_1 
                       sem_Instruction_CallInterface_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 1220 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 1225 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_CallInterface_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_CallMethod :: Word32 ->
                              Word32 ->
                              T_Instruction 
sem_Instruction_CallMethod index_ argCount_  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 1240 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 1245 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_CallMethod_1 :: T_Instruction_1 
                       sem_Instruction_CallMethod_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 1253 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 1258 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_CallMethod_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_CallProp :: Word32 ->
                            Word32 ->
                            T_Instruction 
sem_Instruction_CallProp name_ argCount_  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 1273 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 1278 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_CallProp_1 :: T_Instruction_1 
                       sem_Instruction_CallProp_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 1286 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 1291 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_CallProp_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_CallPropLex :: Word32 ->
                               Word32 ->
                               T_Instruction 
sem_Instruction_CallPropLex name_ argCount_  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 1306 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 1311 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_CallPropLex_1 :: T_Instruction_1 
                       sem_Instruction_CallPropLex_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 1319 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 1324 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_CallPropLex_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_CallPropVoid :: Word32 ->
                                Word32 ->
                                T_Instruction 
sem_Instruction_CallPropVoid name_ argCount_  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 1339 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 1344 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_CallPropVoid_1 :: T_Instruction_1 
                       sem_Instruction_CallPropVoid_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 1352 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 1357 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_CallPropVoid_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_CallStatic :: Word32 ->
                              Word32 ->
                              T_Instruction 
sem_Instruction_CallStatic method_ argCount_  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 1372 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 1377 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_CallStatic_1 :: T_Instruction_1 
                       sem_Instruction_CallStatic_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 1385 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 1390 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_CallStatic_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_CallSuper :: Word32 ->
                             Word32 ->
                             T_Instruction 
sem_Instruction_CallSuper name_ argCount_  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 1405 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 1410 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_CallSuper_1 :: T_Instruction_1 
                       sem_Instruction_CallSuper_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 1418 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 1423 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_CallSuper_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_CallSuperId :: T_Instruction 
sem_Instruction_CallSuperId  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 1436 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 1441 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_CallSuperId_1 :: T_Instruction_1 
                       sem_Instruction_CallSuperId_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 1449 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 1454 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_CallSuperId_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_CallSuperVoid :: Word32 ->
                                 Word32 ->
                                 T_Instruction 
sem_Instruction_CallSuperVoid name_ argCount_  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 1469 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 1474 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_CallSuperVoid_1 :: T_Instruction_1 
                       sem_Instruction_CallSuperVoid_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 1482 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 1487 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_CallSuperVoid_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_CheckFilter :: T_Instruction 
sem_Instruction_CheckFilter  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 1500 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 1505 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_CheckFilter_1 :: T_Instruction_1 
                       sem_Instruction_CheckFilter_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 1513 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 1518 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_CheckFilter_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_Coerce :: Word32 ->
                          T_Instruction 
sem_Instruction_Coerce name_  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 1532 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 1537 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_Coerce_1 :: T_Instruction_1 
                       sem_Instruction_Coerce_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 1545 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 1550 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_Coerce_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_Coerce_a :: T_Instruction 
sem_Instruction_Coerce_a  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 1563 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 1568 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_Coerce_a_1 :: T_Instruction_1 
                       sem_Instruction_Coerce_a_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 1576 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 1581 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_Coerce_a_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_Coerce_b :: T_Instruction 
sem_Instruction_Coerce_b  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 1594 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 1599 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_Coerce_b_1 :: T_Instruction_1 
                       sem_Instruction_Coerce_b_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 1607 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 1612 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_Coerce_b_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_Coerce_d :: T_Instruction 
sem_Instruction_Coerce_d  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 1625 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 1630 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_Coerce_d_1 :: T_Instruction_1 
                       sem_Instruction_Coerce_d_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 1638 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 1643 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_Coerce_d_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_Coerce_i :: T_Instruction 
sem_Instruction_Coerce_i  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 1656 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 1661 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_Coerce_i_1 :: T_Instruction_1 
                       sem_Instruction_Coerce_i_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 1669 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 1674 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_Coerce_i_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_Coerce_o :: T_Instruction 
sem_Instruction_Coerce_o  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 1687 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 1692 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_Coerce_o_1 :: T_Instruction_1 
                       sem_Instruction_Coerce_o_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 1700 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 1705 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_Coerce_o_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_Coerce_s :: T_Instruction 
sem_Instruction_Coerce_s  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 1718 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 1723 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_Coerce_s_1 :: T_Instruction_1 
                       sem_Instruction_Coerce_s_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 1731 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 1736 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_Coerce_s_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_Coerce_u :: T_Instruction 
sem_Instruction_Coerce_u  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 1749 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 1754 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_Coerce_u_1 :: T_Instruction_1 
                       sem_Instruction_Coerce_u_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 1762 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 1767 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_Coerce_u_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_Concat :: T_Instruction 
sem_Instruction_Concat  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 1780 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 1785 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_Concat_1 :: T_Instruction_1 
                       sem_Instruction_Concat_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 1793 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 1798 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_Concat_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_Construct :: Word32 ->
                             T_Instruction 
sem_Instruction_Construct argCount_  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 1812 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 1817 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_Construct_1 :: T_Instruction_1 
                       sem_Instruction_Construct_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 1825 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 1830 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_Construct_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_ConstructProp :: Word32 ->
                                 Word32 ->
                                 T_Instruction 
sem_Instruction_ConstructProp name_ argCount_  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 1845 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 1850 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_ConstructProp_1 :: T_Instruction_1 
                       sem_Instruction_ConstructProp_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 1858 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 1863 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_ConstructProp_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_ConstructSuper :: Word32 ->
                                  T_Instruction 
sem_Instruction_ConstructSuper argCount_  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 1877 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 1882 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_ConstructSuper_1 :: T_Instruction_1 
                       sem_Instruction_ConstructSuper_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 1890 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 1895 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_ConstructSuper_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_Convert_b :: T_Instruction 
sem_Instruction_Convert_b  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 1908 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 1913 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_Convert_b_1 :: T_Instruction_1 
                       sem_Instruction_Convert_b_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 1921 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 1926 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_Convert_b_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_Convert_d :: T_Instruction 
sem_Instruction_Convert_d  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 1939 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 1944 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_Convert_d_1 :: T_Instruction_1 
                       sem_Instruction_Convert_d_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 1952 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 1957 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_Convert_d_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_Convert_i :: T_Instruction 
sem_Instruction_Convert_i  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 1970 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 1975 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_Convert_i_1 :: T_Instruction_1 
                       sem_Instruction_Convert_i_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 1983 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 1988 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_Convert_i_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_Convert_o :: T_Instruction 
sem_Instruction_Convert_o  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 2001 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 2006 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_Convert_o_1 :: T_Instruction_1 
                       sem_Instruction_Convert_o_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 2014 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 2019 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_Convert_o_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_Convert_s :: T_Instruction 
sem_Instruction_Convert_s  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 2032 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 2037 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_Convert_s_1 :: T_Instruction_1 
                       sem_Instruction_Convert_s_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 2045 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 2050 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_Convert_s_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_Convert_u :: T_Instruction 
sem_Instruction_Convert_u  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 2063 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 2068 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_Convert_u_1 :: T_Instruction_1 
                       sem_Instruction_Convert_u_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 2076 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 2081 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_Convert_u_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_Debug :: T_DebugType  ->
                         Word32 ->
                         Word32 ->
                         Word32 ->
                         T_Instruction 
sem_Instruction_Debug tp_ name_ reg_ extra_  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 2098 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 2103 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_Debug_1 :: T_Instruction_1 
                       sem_Instruction_Debug_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 2111 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 2116 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_Debug_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_DebugFile :: Word32 ->
                             T_Instruction 
sem_Instruction_DebugFile name_  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 2130 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 2135 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_DebugFile_1 :: T_Instruction_1 
                       sem_Instruction_DebugFile_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 2143 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 2148 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_DebugFile_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_DebugLine :: Word32 ->
                             T_Instruction 
sem_Instruction_DebugLine line_  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 2162 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 2167 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_DebugLine_1 :: T_Instruction_1 
                       sem_Instruction_DebugLine_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 2175 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 2180 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_DebugLine_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_DecLocal :: Word32 ->
                            T_Instruction 
sem_Instruction_DecLocal reg_  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 2194 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 2199 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_DecLocal_1 :: T_Instruction_1 
                       sem_Instruction_DecLocal_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 2207 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 2212 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_DecLocal_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_DecLocal_i :: Word32 ->
                              T_Instruction 
sem_Instruction_DecLocal_i reg_  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 2226 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 2231 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_DecLocal_i_1 :: T_Instruction_1 
                       sem_Instruction_DecLocal_i_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 2239 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 2244 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_DecLocal_i_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_Decrement :: T_Instruction 
sem_Instruction_Decrement  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 2257 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 2262 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_Decrement_1 :: T_Instruction_1 
                       sem_Instruction_Decrement_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 2270 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 2275 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_Decrement_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_Decrement_i :: T_Instruction 
sem_Instruction_Decrement_i  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 2288 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 2293 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_Decrement_i_1 :: T_Instruction_1 
                       sem_Instruction_Decrement_i_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 2301 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 2306 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_Decrement_i_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_DeleteProperty :: Word32 ->
                                  T_Instruction 
sem_Instruction_DeleteProperty name_  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 2320 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 2325 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_DeleteProperty_1 :: T_Instruction_1 
                       sem_Instruction_DeleteProperty_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 2333 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 2338 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_DeleteProperty_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_DeletePropertyLate :: T_Instruction 
sem_Instruction_DeletePropertyLate  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 2351 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 2356 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_DeletePropertyLate_1 :: T_Instruction_1 
                       sem_Instruction_DeletePropertyLate_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 2364 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 2369 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_DeletePropertyLate_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_Divide :: T_Instruction 
sem_Instruction_Divide  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 2382 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 2387 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_Divide_1 :: T_Instruction_1 
                       sem_Instruction_Divide_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 2395 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 2400 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_Divide_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_Dup :: T_Instruction 
sem_Instruction_Dup  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 2413 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 2418 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_Dup_1 :: T_Instruction_1 
                       sem_Instruction_Dup_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 2426 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 2431 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_Dup_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_Dxns :: Word32 ->
                        T_Instruction 
sem_Instruction_Dxns name_  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 2445 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 2450 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_Dxns_1 :: T_Instruction_1 
                       sem_Instruction_Dxns_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 2458 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 2463 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_Dxns_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_DxnsLate :: T_Instruction 
sem_Instruction_DxnsLate  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 2476 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 2481 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_DxnsLate_1 :: T_Instruction_1 
                       sem_Instruction_DxnsLate_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 2489 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 2494 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_DxnsLate_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_Equals :: T_Instruction 
sem_Instruction_Equals  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 2507 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 2512 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_Equals_1 :: T_Instruction_1 
                       sem_Instruction_Equals_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 2520 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 2525 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_Equals_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_EscXAttr :: T_Instruction 
sem_Instruction_EscXAttr  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 2538 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 2543 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_EscXAttr_1 :: T_Instruction_1 
                       sem_Instruction_EscXAttr_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 2551 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 2556 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_EscXAttr_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_EscXElem :: T_Instruction 
sem_Instruction_EscXElem  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 2569 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 2574 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_EscXElem_1 :: T_Instruction_1 
                       sem_Instruction_EscXElem_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 2582 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 2587 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_EscXElem_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_FindDef :: Word32 ->
                           T_Instruction 
sem_Instruction_FindDef name_  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 2601 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 2606 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_FindDef_1 :: T_Instruction_1 
                       sem_Instruction_FindDef_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 2614 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 2619 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_FindDef_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_FindPropStrict :: Word32 ->
                                  T_Instruction 
sem_Instruction_FindPropStrict name_  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 2633 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 2638 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_FindPropStrict_1 :: T_Instruction_1 
                       sem_Instruction_FindPropStrict_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 2646 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 2651 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_FindPropStrict_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_FindProperty :: Word32 ->
                                T_Instruction 
sem_Instruction_FindProperty name_  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 2665 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 2670 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_FindProperty_1 :: T_Instruction_1 
                       sem_Instruction_FindProperty_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 2678 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 2683 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_FindProperty_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_FindPropertyGlobal :: Word32 ->
                                      T_Instruction 
sem_Instruction_FindPropertyGlobal name_  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 2697 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 2702 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_FindPropertyGlobal_1 :: T_Instruction_1 
                       sem_Instruction_FindPropertyGlobal_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 2710 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 2715 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_FindPropertyGlobal_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_FindPropertyGlobalStrict :: Word32 ->
                                            T_Instruction 
sem_Instruction_FindPropertyGlobalStrict name_  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 2729 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 2734 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_FindPropertyGlobalStrict_1 :: T_Instruction_1 
                       sem_Instruction_FindPropertyGlobalStrict_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 2742 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 2747 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_FindPropertyGlobalStrict_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_GetDescendants :: Word32 ->
                                  T_Instruction 
sem_Instruction_GetDescendants name_  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 2761 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 2766 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_GetDescendants_1 :: T_Instruction_1 
                       sem_Instruction_GetDescendants_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 2774 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 2779 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_GetDescendants_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_GetGlobalScope :: T_Instruction 
sem_Instruction_GetGlobalScope  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 2792 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 2797 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_GetGlobalScope_1 :: T_Instruction_1 
                       sem_Instruction_GetGlobalScope_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 2805 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 2810 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_GetGlobalScope_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_GetGlobalSlot :: Word32 ->
                                 T_Instruction 
sem_Instruction_GetGlobalSlot slot_  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 2824 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 2829 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_GetGlobalSlot_1 :: T_Instruction_1 
                       sem_Instruction_GetGlobalSlot_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 2837 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 2842 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_GetGlobalSlot_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_GetLex :: Word32 ->
                          T_Instruction 
sem_Instruction_GetLex name_  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 2856 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 2861 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_GetLex_1 :: T_Instruction_1 
                       sem_Instruction_GetLex_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 2869 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 2874 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_GetLex_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_GetLocal :: Word32 ->
                            T_Instruction 
sem_Instruction_GetLocal reg_  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 2888 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 2893 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_GetLocal_1 :: T_Instruction_1 
                       sem_Instruction_GetLocal_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 2901 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 2906 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_GetLocal_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_GetLocal0 :: T_Instruction 
sem_Instruction_GetLocal0  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 2919 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 2924 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_GetLocal0_1 :: T_Instruction_1 
                       sem_Instruction_GetLocal0_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 2932 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 2937 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_GetLocal0_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_GetLocal1 :: T_Instruction 
sem_Instruction_GetLocal1  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 2950 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 2955 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_GetLocal1_1 :: T_Instruction_1 
                       sem_Instruction_GetLocal1_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 2963 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 2968 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_GetLocal1_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_GetLocal2 :: T_Instruction 
sem_Instruction_GetLocal2  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 2981 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 2986 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_GetLocal2_1 :: T_Instruction_1 
                       sem_Instruction_GetLocal2_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 2994 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 2999 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_GetLocal2_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_GetLocal3 :: T_Instruction 
sem_Instruction_GetLocal3  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 3012 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 3017 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_GetLocal3_1 :: T_Instruction_1 
                       sem_Instruction_GetLocal3_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 3025 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 3030 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_GetLocal3_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_GetOuterScope :: Word32 ->
                                 T_Instruction 
sem_Instruction_GetOuterScope name_  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 3044 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 3049 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_GetOuterScope_1 :: T_Instruction_1 
                       sem_Instruction_GetOuterScope_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 3057 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 3062 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_GetOuterScope_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_GetProperty :: Word32 ->
                               T_Instruction 
sem_Instruction_GetProperty name_  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 3076 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 3081 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_GetProperty_1 :: T_Instruction_1 
                       sem_Instruction_GetProperty_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 3089 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 3094 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_GetProperty_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_GetScopeObject :: Word8 ->
                                  T_Instruction 
sem_Instruction_GetScopeObject index_  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 3108 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 3113 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_GetScopeObject_1 :: T_Instruction_1 
                       sem_Instruction_GetScopeObject_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 3121 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 3126 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_GetScopeObject_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_GetSlot :: Word32 ->
                           T_Instruction 
sem_Instruction_GetSlot slot_  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 3140 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 3145 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_GetSlot_1 :: T_Instruction_1 
                       sem_Instruction_GetSlot_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 3153 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 3158 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_GetSlot_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_GetSuper :: Word32 ->
                            T_Instruction 
sem_Instruction_GetSuper name_  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 3172 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 3177 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_GetSuper_1 :: T_Instruction_1 
                       sem_Instruction_GetSuper_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 3185 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 3190 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_GetSuper_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_GreaterEquals :: T_Instruction 
sem_Instruction_GreaterEquals  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 3203 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 3208 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_GreaterEquals_1 :: T_Instruction_1 
                       sem_Instruction_GreaterEquals_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 3216 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 3221 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_GreaterEquals_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_GreaterThan :: T_Instruction 
sem_Instruction_GreaterThan  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 3234 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 3239 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_GreaterThan_1 :: T_Instruction_1 
                       sem_Instruction_GreaterThan_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 3247 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 3252 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_GreaterThan_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_HasNext :: T_Instruction 
sem_Instruction_HasNext  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 3265 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 3270 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_HasNext_1 :: T_Instruction_1 
                       sem_Instruction_HasNext_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 3278 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 3283 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_HasNext_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_HasNext2 :: Word32 ->
                            Word32 ->
                            T_Instruction 
sem_Instruction_HasNext2 objectReg_ indexReg_  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 3298 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 3303 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_HasNext2_1 :: T_Instruction_1 
                       sem_Instruction_HasNext2_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 3311 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 3316 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_HasNext2_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_IfEq :: Word32 ->
                        T_Instruction 
sem_Instruction_IfEq offset_  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 3330 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 3335 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_IfEq_1 :: T_Instruction_1 
                       sem_Instruction_IfEq_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 3343 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 3348 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_IfEq_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_IfFalse :: Word32 ->
                           T_Instruction 
sem_Instruction_IfFalse offset_  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 3362 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 3367 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_IfFalse_1 :: T_Instruction_1 
                       sem_Instruction_IfFalse_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 3375 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 3380 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_IfFalse_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_IfGe :: Word32 ->
                        T_Instruction 
sem_Instruction_IfGe offset_  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 3394 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 3399 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_IfGe_1 :: T_Instruction_1 
                       sem_Instruction_IfGe_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 3407 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 3412 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_IfGe_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_IfGt :: Word32 ->
                        T_Instruction 
sem_Instruction_IfGt offset_  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 3426 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 3431 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_IfGt_1 :: T_Instruction_1 
                       sem_Instruction_IfGt_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 3439 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 3444 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_IfGt_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_IfLe :: Word32 ->
                        T_Instruction 
sem_Instruction_IfLe offset_  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 3458 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 3463 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_IfLe_1 :: T_Instruction_1 
                       sem_Instruction_IfLe_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 3471 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 3476 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_IfLe_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_IfLt :: Word32 ->
                        T_Instruction 
sem_Instruction_IfLt offset_  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 3490 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 3495 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_IfLt_1 :: T_Instruction_1 
                       sem_Instruction_IfLt_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 3503 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 3508 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_IfLt_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_IfNGe :: Word32 ->
                         T_Instruction 
sem_Instruction_IfNGe offset_  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 3522 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 3527 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_IfNGe_1 :: T_Instruction_1 
                       sem_Instruction_IfNGe_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 3535 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 3540 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_IfNGe_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_IfNGt :: Word32 ->
                         T_Instruction 
sem_Instruction_IfNGt offset_  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 3554 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 3559 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_IfNGt_1 :: T_Instruction_1 
                       sem_Instruction_IfNGt_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 3567 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 3572 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_IfNGt_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_IfNLe :: Word32 ->
                         T_Instruction 
sem_Instruction_IfNLe offset_  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 3586 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 3591 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_IfNLe_1 :: T_Instruction_1 
                       sem_Instruction_IfNLe_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 3599 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 3604 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_IfNLe_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_IfNLt :: Word32 ->
                         T_Instruction 
sem_Instruction_IfNLt offset_  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 3618 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 3623 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_IfNLt_1 :: T_Instruction_1 
                       sem_Instruction_IfNLt_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 3631 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 3636 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_IfNLt_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_IfNe :: Word32 ->
                        T_Instruction 
sem_Instruction_IfNe offset_  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 3650 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 3655 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_IfNe_1 :: T_Instruction_1 
                       sem_Instruction_IfNe_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 3663 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 3668 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_IfNe_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_IfStrictEq :: Word32 ->
                              T_Instruction 
sem_Instruction_IfStrictEq offset_  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 3682 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 3687 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_IfStrictEq_1 :: T_Instruction_1 
                       sem_Instruction_IfStrictEq_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 3695 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 3700 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_IfStrictEq_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_IfStrictNe :: Word32 ->
                              T_Instruction 
sem_Instruction_IfStrictNe offset_  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 3714 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 3719 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_IfStrictNe_1 :: T_Instruction_1 
                       sem_Instruction_IfStrictNe_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 3727 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 3732 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_IfStrictNe_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_IfTrue :: Word32 ->
                          T_Instruction 
sem_Instruction_IfTrue offset_  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 3746 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 3751 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_IfTrue_1 :: T_Instruction_1 
                       sem_Instruction_IfTrue_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 3759 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 3764 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_IfTrue_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_In :: T_Instruction 
sem_Instruction_In  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 3777 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 3782 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_In_1 :: T_Instruction_1 
                       sem_Instruction_In_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 3790 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 3795 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_In_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_IncLocal :: Word32 ->
                            T_Instruction 
sem_Instruction_IncLocal reg_  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 3809 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 3814 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_IncLocal_1 :: T_Instruction_1 
                       sem_Instruction_IncLocal_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 3822 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 3827 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_IncLocal_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_IncLocal_i :: Word32 ->
                              T_Instruction 
sem_Instruction_IncLocal_i reg_  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 3841 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 3846 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_IncLocal_i_1 :: T_Instruction_1 
                       sem_Instruction_IncLocal_i_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 3854 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 3859 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_IncLocal_i_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_Increment :: T_Instruction 
sem_Instruction_Increment  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 3872 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 3877 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_Increment_1 :: T_Instruction_1 
                       sem_Instruction_Increment_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 3885 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 3890 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_Increment_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_Increment_i :: T_Instruction 
sem_Instruction_Increment_i  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 3903 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 3908 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_Increment_i_1 :: T_Instruction_1 
                       sem_Instruction_Increment_i_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 3916 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 3921 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_Increment_i_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_InitProperty :: Word32 ->
                                T_Instruction 
sem_Instruction_InitProperty name_  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 3935 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 3940 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_InitProperty_1 :: T_Instruction_1 
                       sem_Instruction_InitProperty_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 3948 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 3953 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_InitProperty_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_InstanceOf :: T_Instruction 
sem_Instruction_InstanceOf  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 3966 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 3971 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_InstanceOf_1 :: T_Instruction_1 
                       sem_Instruction_InstanceOf_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 3979 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 3984 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_InstanceOf_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_IsType :: Word32 ->
                          T_Instruction 
sem_Instruction_IsType name_  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 3998 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 4003 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_IsType_1 :: T_Instruction_1 
                       sem_Instruction_IsType_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 4011 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 4016 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_IsType_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_IsTypeLate :: T_Instruction 
sem_Instruction_IsTypeLate  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 4029 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 4034 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_IsTypeLate_1 :: T_Instruction_1 
                       sem_Instruction_IsTypeLate_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 4042 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 4047 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_IsTypeLate_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_Jump :: Word32 ->
                        T_Instruction 
sem_Instruction_Jump offset_  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 4061 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 4066 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_Jump_1 :: T_Instruction_1 
                       sem_Instruction_Jump_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 4074 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 4079 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_Jump_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_Kill :: Word32 ->
                        T_Instruction 
sem_Instruction_Kill reg_  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 4093 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 4098 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_Kill_1 :: T_Instruction_1 
                       sem_Instruction_Kill_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 4106 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 4111 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_Kill_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_Label :: T_Instruction 
sem_Instruction_Label  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 4124 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 4129 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_Label_1 :: T_Instruction_1 
                       sem_Instruction_Label_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 4137 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 4142 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_Label_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_LessEquals :: T_Instruction 
sem_Instruction_LessEquals  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 4155 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 4160 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_LessEquals_1 :: T_Instruction_1 
                       sem_Instruction_LessEquals_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 4168 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 4173 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_LessEquals_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_LessThan :: T_Instruction 
sem_Instruction_LessThan  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 4186 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 4191 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_LessThan_1 :: T_Instruction_1 
                       sem_Instruction_LessThan_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 4199 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 4204 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_LessThan_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_LoadFloat32 :: T_Instruction 
sem_Instruction_LoadFloat32  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 4217 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 4222 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_LoadFloat32_1 :: T_Instruction_1 
                       sem_Instruction_LoadFloat32_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 4230 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 4235 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_LoadFloat32_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_LoadFloat64 :: T_Instruction 
sem_Instruction_LoadFloat64  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 4248 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 4253 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_LoadFloat64_1 :: T_Instruction_1 
                       sem_Instruction_LoadFloat64_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 4261 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 4266 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_LoadFloat64_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_LoadIndirect16 :: T_Instruction 
sem_Instruction_LoadIndirect16  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 4279 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 4284 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_LoadIndirect16_1 :: T_Instruction_1 
                       sem_Instruction_LoadIndirect16_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 4292 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 4297 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_LoadIndirect16_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_LoadIndirect32 :: T_Instruction 
sem_Instruction_LoadIndirect32  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 4310 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 4315 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_LoadIndirect32_1 :: T_Instruction_1 
                       sem_Instruction_LoadIndirect32_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 4323 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 4328 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_LoadIndirect32_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_LoadIndirect8 :: T_Instruction 
sem_Instruction_LoadIndirect8  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 4341 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 4346 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_LoadIndirect8_1 :: T_Instruction_1 
                       sem_Instruction_LoadIndirect8_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 4354 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 4359 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_LoadIndirect8_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_Location :: Int ->
                            T_Instruction 
sem_Instruction_Location index_  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 4373 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 7 "src/ByteCodeLocationInfo.ag" #-}
                  index_
                  {-# LINE 4378 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_Location_1 :: T_Instruction_1 
                       sem_Instruction_Location_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 4386 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 11 "src/ByteCodeLocationInfo.ag" #-}
                                         index_
                                         {-# LINE 4391 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_Location_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_LookupSwitch :: Word32 ->
                                T_CaseOffsets  ->
                                T_Instruction 
sem_Instruction_LookupSwitch defaultOffset_ caseOffsets_  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 4406 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 4411 "src/TrfToCFG.hs" #-}
                  )) of
           { _caseOffsetsOlocation | _caseOffsetsOlocation `seq` (True) ->
           (case (caseOffsets_ _caseOffsetsOlocation ) of
            { ( _caseOffsetsIlocation,caseOffsets_1) | True ->
                (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                        _caseOffsetsIlocation
                        {-# LINE 4418 "src/TrfToCFG.hs" #-}
                        )) of
                 { _lhsOlocation | _lhsOlocation `seq` (True) ->
                 (case ((let sem_Instruction_LookupSwitch_1 :: T_Instruction_1 
                             sem_Instruction_LookupSwitch_1  =
                                 (\ _lhsIrevLocation ->
                                      (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                              []
                                              {-# LINE 4426 "src/TrfToCFG.hs" #-}
                                              )) of
                                       { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                       (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                               _lhsIrevLocation
                                               {-# LINE 4431 "src/TrfToCFG.hs" #-}
                                               )) of
                                        { _caseOffsetsOrevLocation | _caseOffsetsOrevLocation `seq` (True) ->
                                        (case (caseOffsets_1 _caseOffsetsOrevLocation ) of
                                         { ( _caseOffsetsIrevLocation) | True ->
                                             (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                                     _caseOffsetsIrevLocation
                                                     {-# LINE 4438 "src/TrfToCFG.hs" #-}
                                                     )) of
                                              { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                              ( _lhsOgraphs,_lhsOrevLocation) }) }) }) }))
                         in  sem_Instruction_LookupSwitch_1)) of
                  { ( sem_Instruction_1) | True ->
                  ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }) }) }))
sem_Instruction_Lshift :: T_Instruction 
sem_Instruction_Lshift  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 4451 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 4456 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_Lshift_1 :: T_Instruction_1 
                       sem_Instruction_Lshift_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 4464 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 4469 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_Lshift_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_Modulo :: T_Instruction 
sem_Instruction_Modulo  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 4482 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 4487 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_Modulo_1 :: T_Instruction_1 
                       sem_Instruction_Modulo_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 4495 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 4500 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_Modulo_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_Multiply :: T_Instruction 
sem_Instruction_Multiply  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 4513 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 4518 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_Multiply_1 :: T_Instruction_1 
                       sem_Instruction_Multiply_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 4526 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 4531 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_Multiply_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_Multiply_i :: T_Instruction 
sem_Instruction_Multiply_i  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 4544 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 4549 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_Multiply_i_1 :: T_Instruction_1 
                       sem_Instruction_Multiply_i_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 4557 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 4562 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_Multiply_i_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_Negate :: T_Instruction 
sem_Instruction_Negate  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 4575 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 4580 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_Negate_1 :: T_Instruction_1 
                       sem_Instruction_Negate_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 4588 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 4593 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_Negate_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_Negate_i :: T_Instruction 
sem_Instruction_Negate_i  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 4606 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 4611 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_Negate_i_1 :: T_Instruction_1 
                       sem_Instruction_Negate_i_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 4619 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 4624 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_Negate_i_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_NewActivation :: T_Instruction 
sem_Instruction_NewActivation  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 4637 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 4642 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_NewActivation_1 :: T_Instruction_1 
                       sem_Instruction_NewActivation_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 4650 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 4655 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_NewActivation_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_NewArray :: Word32 ->
                            T_Instruction 
sem_Instruction_NewArray argCount_  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 4669 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 4674 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_NewArray_1 :: T_Instruction_1 
                       sem_Instruction_NewArray_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 4682 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 4687 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_NewArray_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_NewCatch :: Word32 ->
                            T_Instruction 
sem_Instruction_NewCatch exception_  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 4701 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 4706 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_NewCatch_1 :: T_Instruction_1 
                       sem_Instruction_NewCatch_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 4714 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 4719 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_NewCatch_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_NewClass :: Word32 ->
                            T_Instruction 
sem_Instruction_NewClass class_  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 4733 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 4738 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_NewClass_1 :: T_Instruction_1 
                       sem_Instruction_NewClass_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 4746 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 4751 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_NewClass_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_NewFunction :: Word32 ->
                               T_Instruction 
sem_Instruction_NewFunction method_  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 4765 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 4770 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_NewFunction_1 :: T_Instruction_1 
                       sem_Instruction_NewFunction_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 4778 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 4783 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_NewFunction_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_NewObject :: Word32 ->
                             T_Instruction 
sem_Instruction_NewObject argCount_  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 4797 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 4802 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_NewObject_1 :: T_Instruction_1 
                       sem_Instruction_NewObject_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 4810 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 4815 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_NewObject_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_NextName :: T_Instruction 
sem_Instruction_NextName  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 4828 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 4833 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_NextName_1 :: T_Instruction_1 
                       sem_Instruction_NextName_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 4841 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 4846 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_NextName_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_NextValue :: T_Instruction 
sem_Instruction_NextValue  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 4859 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 4864 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_NextValue_1 :: T_Instruction_1 
                       sem_Instruction_NextValue_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 4872 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 4877 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_NextValue_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_Nop :: T_Instruction 
sem_Instruction_Nop  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 4890 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 4895 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_Nop_1 :: T_Instruction_1 
                       sem_Instruction_Nop_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 4903 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 4908 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_Nop_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_Not :: T_Instruction 
sem_Instruction_Not  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 4921 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 4926 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_Not_1 :: T_Instruction_1 
                       sem_Instruction_Not_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 4934 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 4939 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_Not_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_Pop :: T_Instruction 
sem_Instruction_Pop  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 4952 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 4957 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_Pop_1 :: T_Instruction_1 
                       sem_Instruction_Pop_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 4965 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 4970 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_Pop_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_PopScope :: T_Instruction 
sem_Instruction_PopScope  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 4983 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 4988 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_PopScope_1 :: T_Instruction_1 
                       sem_Instruction_PopScope_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 4996 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 5001 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_PopScope_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_PushByte :: Word8 ->
                            T_Instruction 
sem_Instruction_PushByte val_  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 5015 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 5020 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_PushByte_1 :: T_Instruction_1 
                       sem_Instruction_PushByte_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 5028 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 5033 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_PushByte_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_PushDouble :: Word32 ->
                              T_Instruction 
sem_Instruction_PushDouble name_  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 5047 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 5052 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_PushDouble_1 :: T_Instruction_1 
                       sem_Instruction_PushDouble_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 5060 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 5065 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_PushDouble_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_PushFalse :: T_Instruction 
sem_Instruction_PushFalse  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 5078 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 5083 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_PushFalse_1 :: T_Instruction_1 
                       sem_Instruction_PushFalse_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 5091 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 5096 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_PushFalse_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_PushInt :: Word32 ->
                           T_Instruction 
sem_Instruction_PushInt name_  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 5110 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 5115 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_PushInt_1 :: T_Instruction_1 
                       sem_Instruction_PushInt_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 5123 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 5128 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_PushInt_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_PushNaN :: T_Instruction 
sem_Instruction_PushNaN  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 5141 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 5146 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_PushNaN_1 :: T_Instruction_1 
                       sem_Instruction_PushNaN_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 5154 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 5159 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_PushNaN_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_PushNamespace :: Word32 ->
                                 T_Instruction 
sem_Instruction_PushNamespace name_  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 5173 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 5178 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_PushNamespace_1 :: T_Instruction_1 
                       sem_Instruction_PushNamespace_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 5186 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 5191 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_PushNamespace_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_PushNull :: T_Instruction 
sem_Instruction_PushNull  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 5204 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 5209 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_PushNull_1 :: T_Instruction_1 
                       sem_Instruction_PushNull_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 5217 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 5222 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_PushNull_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_PushScope :: T_Instruction 
sem_Instruction_PushScope  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 5235 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 5240 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_PushScope_1 :: T_Instruction_1 
                       sem_Instruction_PushScope_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 5248 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 5253 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_PushScope_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_PushShort :: Word32 ->
                             T_Instruction 
sem_Instruction_PushShort val_  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 5267 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 5272 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_PushShort_1 :: T_Instruction_1 
                       sem_Instruction_PushShort_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 5280 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 5285 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_PushShort_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_PushString :: Word32 ->
                              T_Instruction 
sem_Instruction_PushString name_  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 5299 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 5304 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_PushString_1 :: T_Instruction_1 
                       sem_Instruction_PushString_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 5312 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 5317 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_PushString_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_PushTrue :: T_Instruction 
sem_Instruction_PushTrue  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 5330 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 5335 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_PushTrue_1 :: T_Instruction_1 
                       sem_Instruction_PushTrue_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 5343 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 5348 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_PushTrue_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_PushUInt :: Word32 ->
                            T_Instruction 
sem_Instruction_PushUInt name_  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 5362 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 5367 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_PushUInt_1 :: T_Instruction_1 
                       sem_Instruction_PushUInt_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 5375 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 5380 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_PushUInt_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_PushUndefined :: T_Instruction 
sem_Instruction_PushUndefined  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 5393 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 5398 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_PushUndefined_1 :: T_Instruction_1 
                       sem_Instruction_PushUndefined_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 5406 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 5411 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_PushUndefined_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_PushWith :: T_Instruction 
sem_Instruction_PushWith  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 5424 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 5429 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_PushWith_1 :: T_Instruction_1 
                       sem_Instruction_PushWith_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 5437 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 5442 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_PushWith_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_ReturnValue :: T_Instruction 
sem_Instruction_ReturnValue  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 5455 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 5460 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_ReturnValue_1 :: T_Instruction_1 
                       sem_Instruction_ReturnValue_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 5468 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 5473 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_ReturnValue_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_ReturnVoid :: T_Instruction 
sem_Instruction_ReturnVoid  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 5486 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 5491 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_ReturnVoid_1 :: T_Instruction_1 
                       sem_Instruction_ReturnVoid_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 5499 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 5504 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_ReturnVoid_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_Rshift :: T_Instruction 
sem_Instruction_Rshift  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 5517 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 5522 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_Rshift_1 :: T_Instruction_1 
                       sem_Instruction_Rshift_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 5530 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 5535 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_Rshift_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_SetGlobalSlot :: Word32 ->
                                 T_Instruction 
sem_Instruction_SetGlobalSlot slot_  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 5549 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 5554 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_SetGlobalSlot_1 :: T_Instruction_1 
                       sem_Instruction_SetGlobalSlot_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 5562 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 5567 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_SetGlobalSlot_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_SetLocal :: Word32 ->
                            T_Instruction 
sem_Instruction_SetLocal reg_  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 5581 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 5586 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_SetLocal_1 :: T_Instruction_1 
                       sem_Instruction_SetLocal_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 5594 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 5599 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_SetLocal_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_SetLocal0 :: T_Instruction 
sem_Instruction_SetLocal0  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 5612 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 5617 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_SetLocal0_1 :: T_Instruction_1 
                       sem_Instruction_SetLocal0_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 5625 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 5630 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_SetLocal0_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_SetLocal1 :: T_Instruction 
sem_Instruction_SetLocal1  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 5643 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 5648 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_SetLocal1_1 :: T_Instruction_1 
                       sem_Instruction_SetLocal1_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 5656 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 5661 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_SetLocal1_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_SetLocal2 :: T_Instruction 
sem_Instruction_SetLocal2  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 5674 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 5679 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_SetLocal2_1 :: T_Instruction_1 
                       sem_Instruction_SetLocal2_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 5687 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 5692 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_SetLocal2_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_SetLocal3 :: T_Instruction 
sem_Instruction_SetLocal3  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 5705 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 5710 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_SetLocal3_1 :: T_Instruction_1 
                       sem_Instruction_SetLocal3_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 5718 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 5723 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_SetLocal3_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_SetProperty :: Word32 ->
                               T_Instruction 
sem_Instruction_SetProperty name_  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 5737 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 5742 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_SetProperty_1 :: T_Instruction_1 
                       sem_Instruction_SetProperty_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 5750 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 5755 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_SetProperty_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_SetPropertyLate :: T_Instruction 
sem_Instruction_SetPropertyLate  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 5768 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 5773 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_SetPropertyLate_1 :: T_Instruction_1 
                       sem_Instruction_SetPropertyLate_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 5781 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 5786 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_SetPropertyLate_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_SetSlot :: Word32 ->
                           T_Instruction 
sem_Instruction_SetSlot slot_  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 5800 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 5805 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_SetSlot_1 :: T_Instruction_1 
                       sem_Instruction_SetSlot_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 5813 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 5818 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_SetSlot_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_SetSuper :: Word32 ->
                            T_Instruction 
sem_Instruction_SetSuper name_  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 5832 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 5837 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_SetSuper_1 :: T_Instruction_1 
                       sem_Instruction_SetSuper_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 5845 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 5850 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_SetSuper_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_SignExtend1 :: T_Instruction 
sem_Instruction_SignExtend1  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 5863 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 5868 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_SignExtend1_1 :: T_Instruction_1 
                       sem_Instruction_SignExtend1_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 5876 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 5881 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_SignExtend1_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_SignExtend16 :: T_Instruction 
sem_Instruction_SignExtend16  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 5894 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 5899 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_SignExtend16_1 :: T_Instruction_1 
                       sem_Instruction_SignExtend16_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 5907 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 5912 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_SignExtend16_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_SignExtend8 :: T_Instruction 
sem_Instruction_SignExtend8  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 5925 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 5930 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_SignExtend8_1 :: T_Instruction_1 
                       sem_Instruction_SignExtend8_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 5938 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 5943 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_SignExtend8_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_StoreFloat32 :: T_Instruction 
sem_Instruction_StoreFloat32  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 5956 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 5961 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_StoreFloat32_1 :: T_Instruction_1 
                       sem_Instruction_StoreFloat32_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 5969 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 5974 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_StoreFloat32_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_StoreFloat64 :: T_Instruction 
sem_Instruction_StoreFloat64  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 5987 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 5992 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_StoreFloat64_1 :: T_Instruction_1 
                       sem_Instruction_StoreFloat64_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 6000 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 6005 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_StoreFloat64_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_StoreIndirect16 :: T_Instruction 
sem_Instruction_StoreIndirect16  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 6018 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 6023 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_StoreIndirect16_1 :: T_Instruction_1 
                       sem_Instruction_StoreIndirect16_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 6031 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 6036 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_StoreIndirect16_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_StoreIndirect32 :: T_Instruction 
sem_Instruction_StoreIndirect32  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 6049 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 6054 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_StoreIndirect32_1 :: T_Instruction_1 
                       sem_Instruction_StoreIndirect32_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 6062 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 6067 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_StoreIndirect32_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_StoreIndirect8 :: T_Instruction 
sem_Instruction_StoreIndirect8  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 6080 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 6085 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_StoreIndirect8_1 :: T_Instruction_1 
                       sem_Instruction_StoreIndirect8_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 6093 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 6098 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_StoreIndirect8_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_StrictEquals :: T_Instruction 
sem_Instruction_StrictEquals  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 6111 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 6116 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_StrictEquals_1 :: T_Instruction_1 
                       sem_Instruction_StrictEquals_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 6124 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 6129 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_StrictEquals_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_Substract :: T_Instruction 
sem_Instruction_Substract  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 6142 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 6147 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_Substract_1 :: T_Instruction_1 
                       sem_Instruction_Substract_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 6155 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 6160 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_Substract_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_Substract_i :: T_Instruction 
sem_Instruction_Substract_i  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 6173 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 6178 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_Substract_i_1 :: T_Instruction_1 
                       sem_Instruction_Substract_i_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 6186 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 6191 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_Substract_i_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_Swap :: T_Instruction 
sem_Instruction_Swap  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 6204 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 6209 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_Swap_1 :: T_Instruction_1 
                       sem_Instruction_Swap_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 6217 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 6222 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_Swap_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_Throw :: T_Instruction 
sem_Instruction_Throw  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 6235 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 6240 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_Throw_1 :: T_Instruction_1 
                       sem_Instruction_Throw_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 6248 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 6253 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_Throw_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_Timestamp :: T_Instruction 
sem_Instruction_Timestamp  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 6266 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 6271 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_Timestamp_1 :: T_Instruction_1 
                       sem_Instruction_Timestamp_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 6279 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 6284 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_Timestamp_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_TypeOf :: T_Instruction 
sem_Instruction_TypeOf  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 6297 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 6302 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_TypeOf_1 :: T_Instruction_1 
                       sem_Instruction_TypeOf_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 6310 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 6315 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_TypeOf_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
sem_Instruction_Urshift :: T_Instruction 
sem_Instruction_Urshift  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 6328 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 6333 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instruction_Urshift_1 :: T_Instruction_1 
                       sem_Instruction_Urshift_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 6341 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 6346 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instruction_Urshift_1)) of
            { ( sem_Instruction_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instruction_1) }) }) }))
-- Instructions ------------------------------------------------
-- cata
sem_Instructions :: Instructions  ->
                    T_Instructions 
sem_Instructions list  =
    (Prelude.foldr sem_Instructions_Cons sem_Instructions_Nil (Prelude.map sem_Instruction list) )
-- semantic domain
type T_Instructions  = Int ->
                       Int ->
                       ( Int,Int,T_Instructions_1 )
type T_Instructions_1  = Int ->
                         ( CFGs,Int)
sem_Instructions_Cons :: T_Instruction  ->
                         T_Instructions  ->
                         T_Instructions 
sem_Instructions_Cons hd_ tl_  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 6373 "src/TrfToCFG.hs" #-}
                 )) of
          { _hdOguid | _hdOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 6378 "src/TrfToCFG.hs" #-}
                  )) of
           { _hdOlocation | _hdOlocation `seq` (True) ->
           (case (hd_ _hdOguid _hdOlocation ) of
            { ( _hdIguid,_hdIlocation,hd_1) | True ->
                (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                        _hdIguid
                        {-# LINE 6385 "src/TrfToCFG.hs" #-}
                        )) of
                 { _tlOguid | _tlOguid `seq` (True) ->
                 (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                         _hdIlocation
                         {-# LINE 6390 "src/TrfToCFG.hs" #-}
                         )) of
                  { _tlOlocation | _tlOlocation `seq` (True) ->
                  (case (tl_ _tlOguid _tlOlocation ) of
                   { ( _tlIguid,_tlIlocation,tl_1) | True ->
                       (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                               _tlIguid
                               {-# LINE 6397 "src/TrfToCFG.hs" #-}
                               )) of
                        { _lhsOguid | _lhsOguid `seq` (True) ->
                        (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                                _tlIlocation
                                {-# LINE 6402 "src/TrfToCFG.hs" #-}
                                )) of
                         { _lhsOlocation | _lhsOlocation `seq` (True) ->
                         (case ((let sem_Instructions_Cons_1 :: T_Instructions_1 
                                     sem_Instructions_Cons_1  =
                                         (\ _lhsIrevLocation ->
                                              (case (({-# LINE 13 "src/ByteCodeLocationInfo.ag" #-}
                                                      _lhsIrevLocation
                                                      {-# LINE 6410 "src/TrfToCFG.hs" #-}
                                                      )) of
                                               { _tlOrevLocation | _tlOrevLocation `seq` (True) ->
                                               (case (tl_1 _tlOrevLocation ) of
                                                { ( _tlIgraphs,_tlIrevLocation) | True ->
                                                    (case (({-# LINE 14 "src/ByteCodeLocationInfo.ag" #-}
                                                            _tlIrevLocation
                                                            {-# LINE 6417 "src/TrfToCFG.hs" #-}
                                                            )) of
                                                     { _hdOrevLocation | _hdOrevLocation `seq` (True) ->
                                                     (case (hd_1 _hdOrevLocation ) of
                                                      { ( _hdIgraphs,_hdIrevLocation) | True ->
                                                          (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                                                  _hdIgraphs ++ _tlIgraphs
                                                                  {-# LINE 6424 "src/TrfToCFG.hs" #-}
                                                                  )) of
                                                           { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                                           (case (({-# LINE 15 "src/ByteCodeLocationInfo.ag" #-}
                                                                   _hdIrevLocation
                                                                   {-# LINE 6429 "src/TrfToCFG.hs" #-}
                                                                   )) of
                                                            { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                                            ( _lhsOgraphs,_lhsOrevLocation) }) }) }) }) }) }))
                                 in  sem_Instructions_Cons_1)) of
                          { ( sem_Instructions_1) | True ->
                          ( _lhsOguid,_lhsOlocation,sem_Instructions_1) }) }) }) }) }) }) }) }) }))
sem_Instructions_Nil :: T_Instructions 
sem_Instructions_Nil  =
    (\ _lhsIguid
       _lhsIlocation ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 6442 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 6 "src/ByteCodeLocationInfo.ag" #-}
                  _lhsIlocation
                  {-# LINE 6447 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOlocation | _lhsOlocation `seq` (True) ->
           (case ((let sem_Instructions_Nil_1 :: T_Instructions_1 
                       sem_Instructions_Nil_1  =
                           (\ _lhsIrevLocation ->
                                (case (({-# LINE 45 "src/TrfToCFG.ag" #-}
                                        []
                                        {-# LINE 6455 "src/TrfToCFG.hs" #-}
                                        )) of
                                 { _lhsOgraphs | _lhsOgraphs `seq` (True) ->
                                 (case (({-# LINE 10 "src/ByteCodeLocationInfo.ag" #-}
                                         _lhsIrevLocation
                                         {-# LINE 6460 "src/TrfToCFG.hs" #-}
                                         )) of
                                  { _lhsOrevLocation | _lhsOrevLocation `seq` (True) ->
                                  ( _lhsOgraphs,_lhsOrevLocation) }) }))
                   in  sem_Instructions_Nil_1)) of
            { ( sem_Instructions_1) | True ->
            ( _lhsOguid,_lhsOlocation,sem_Instructions_1) }) }) }))
-- Interfaces --------------------------------------------------
-- cata
sem_Interfaces :: Interfaces  ->
                  T_Interfaces 
sem_Interfaces list  =
    (Prelude.foldr sem_Interfaces_Cons sem_Interfaces_Nil list )
-- semantic domain
type T_Interfaces  = ( )
sem_Interfaces_Cons :: Word32 ->
                       T_Interfaces  ->
                       T_Interfaces 
sem_Interfaces_Cons hd_ tl_  =
    ( )
sem_Interfaces_Nil :: T_Interfaces 
sem_Interfaces_Nil  =
    ( )
-- MetaInfo ----------------------------------------------------
-- cata
sem_MetaInfo :: MetaInfo  ->
                T_MetaInfo 
sem_MetaInfo (MetaInfo_Info _name _items )  =
    (sem_MetaInfo_Info _name (sem_MetaItems _items ) )
-- semantic domain
type T_MetaInfo  = ( )
sem_MetaInfo_Info :: Word32 ->
                     T_MetaItems  ->
                     T_MetaInfo 
sem_MetaInfo_Info name_ items_  =
    ( )
-- MetaInfos ---------------------------------------------------
-- cata
sem_MetaInfos :: MetaInfos  ->
                 T_MetaInfos 
sem_MetaInfos list  =
    (Prelude.foldr sem_MetaInfos_Cons sem_MetaInfos_Nil (Prelude.map sem_MetaInfo list) )
-- semantic domain
type T_MetaInfos  = ( )
sem_MetaInfos_Cons :: T_MetaInfo  ->
                      T_MetaInfos  ->
                      T_MetaInfos 
sem_MetaInfos_Cons hd_ tl_  =
    ( )
sem_MetaInfos_Nil :: T_MetaInfos 
sem_MetaInfos_Nil  =
    ( )
-- MetaItem ----------------------------------------------------
-- cata
sem_MetaItem :: MetaItem  ->
                T_MetaItem 
sem_MetaItem (MetaItem_Item _key _value )  =
    (sem_MetaItem_Item _key _value )
-- semantic domain
type T_MetaItem  = ( )
sem_MetaItem_Item :: Word32 ->
                     Word32 ->
                     T_MetaItem 
sem_MetaItem_Item key_ value_  =
    ( )
-- MetaItems ---------------------------------------------------
-- cata
sem_MetaItems :: MetaItems  ->
                 T_MetaItems 
sem_MetaItems list  =
    (Prelude.foldr sem_MetaItems_Cons sem_MetaItems_Nil (Prelude.map sem_MetaItem list) )
-- semantic domain
type T_MetaItems  = ( )
sem_MetaItems_Cons :: T_MetaItem  ->
                      T_MetaItems  ->
                      T_MetaItems 
sem_MetaItems_Cons hd_ tl_  =
    ( )
sem_MetaItems_Nil :: T_MetaItems 
sem_MetaItems_Nil  =
    ( )
-- MethodFlag --------------------------------------------------
-- cata
sem_MethodFlag :: MethodFlag  ->
                  T_MethodFlag 
sem_MethodFlag (MethodFlag_HasOptionals )  =
    (sem_MethodFlag_HasOptionals )
sem_MethodFlag (MethodFlag_HasParamNames )  =
    (sem_MethodFlag_HasParamNames )
sem_MethodFlag (MethodFlag_NeedAct )  =
    (sem_MethodFlag_NeedAct )
sem_MethodFlag (MethodFlag_NeedArgs )  =
    (sem_MethodFlag_NeedArgs )
sem_MethodFlag (MethodFlag_NeedRest )  =
    (sem_MethodFlag_NeedRest )
sem_MethodFlag (MethodFlag_SetDXNS )  =
    (sem_MethodFlag_SetDXNS )
-- semantic domain
type T_MethodFlag  = ( )
sem_MethodFlag_HasOptionals :: T_MethodFlag 
sem_MethodFlag_HasOptionals  =
    ( )
sem_MethodFlag_HasParamNames :: T_MethodFlag 
sem_MethodFlag_HasParamNames  =
    ( )
sem_MethodFlag_NeedAct :: T_MethodFlag 
sem_MethodFlag_NeedAct  =
    ( )
sem_MethodFlag_NeedArgs :: T_MethodFlag 
sem_MethodFlag_NeedArgs  =
    ( )
sem_MethodFlag_NeedRest :: T_MethodFlag 
sem_MethodFlag_NeedRest  =
    ( )
sem_MethodFlag_SetDXNS :: T_MethodFlag 
sem_MethodFlag_SetDXNS  =
    ( )
-- MethodFlags -------------------------------------------------
-- cata
sem_MethodFlags :: MethodFlags  ->
                   T_MethodFlags 
sem_MethodFlags list  =
    (Prelude.foldr sem_MethodFlags_Cons sem_MethodFlags_Nil (Prelude.map sem_MethodFlag list) )
-- semantic domain
type T_MethodFlags  = ( )
sem_MethodFlags_Cons :: T_MethodFlag  ->
                        T_MethodFlags  ->
                        T_MethodFlags 
sem_MethodFlags_Cons hd_ tl_  =
    ( )
sem_MethodFlags_Nil :: T_MethodFlags 
sem_MethodFlags_Nil  =
    ( )
-- MethodInfo --------------------------------------------------
-- cata
sem_MethodInfo :: MethodInfo  ->
                  T_MethodInfo 
sem_MethodInfo (MethodInfo_Info _return _params _name _flags _options _names )  =
    (sem_MethodInfo_Info _return (sem_ParamTypes _params ) _name (sem_MethodFlags _flags ) (sem_Optionals _options ) (sem_ParamNames _names ) )
-- semantic domain
type T_MethodInfo  = ( )
sem_MethodInfo_Info :: Word32 ->
                       T_ParamTypes  ->
                       Word32 ->
                       T_MethodFlags  ->
                       T_Optionals  ->
                       T_ParamNames  ->
                       T_MethodInfo 
sem_MethodInfo_Info return_ params_ name_ flags_ options_ names_  =
    ( )
-- MethodInfos -------------------------------------------------
-- cata
sem_MethodInfos :: MethodInfos  ->
                   T_MethodInfos 
sem_MethodInfos list  =
    (Prelude.foldr sem_MethodInfos_Cons sem_MethodInfos_Nil (Prelude.map sem_MethodInfo list) )
-- semantic domain
type T_MethodInfos  = ( )
sem_MethodInfos_Cons :: T_MethodInfo  ->
                        T_MethodInfos  ->
                        T_MethodInfos 
sem_MethodInfos_Cons hd_ tl_  =
    ( )
sem_MethodInfos_Nil :: T_MethodInfos 
sem_MethodInfos_Nil  =
    ( )
-- MultinameInfo -----------------------------------------------
-- cata
sem_MultinameInfo :: MultinameInfo  ->
                     T_MultinameInfo 
sem_MultinameInfo (MultinameInfo_Generic _name _params )  =
    (sem_MultinameInfo_Generic _name (sem_ParamNames _params ) )
sem_MultinameInfo (MultinameInfo_Multiname _name _set )  =
    (sem_MultinameInfo_Multiname _name _set )
sem_MultinameInfo (MultinameInfo_MultinameA _name _set )  =
    (sem_MultinameInfo_MultinameA _name _set )
sem_MultinameInfo (MultinameInfo_MultinameL _set )  =
    (sem_MultinameInfo_MultinameL _set )
sem_MultinameInfo (MultinameInfo_MultinameLA _set )  =
    (sem_MultinameInfo_MultinameLA _set )
sem_MultinameInfo (MultinameInfo_QName _namespace _name )  =
    (sem_MultinameInfo_QName _namespace _name )
sem_MultinameInfo (MultinameInfo_QNameA _namespace _name )  =
    (sem_MultinameInfo_QNameA _namespace _name )
sem_MultinameInfo (MultinameInfo_RTQName _name )  =
    (sem_MultinameInfo_RTQName _name )
sem_MultinameInfo (MultinameInfo_RTQNameA _name )  =
    (sem_MultinameInfo_RTQNameA _name )
sem_MultinameInfo (MultinameInfo_RTQNameL )  =
    (sem_MultinameInfo_RTQNameL )
sem_MultinameInfo (MultinameInfo_RTQNameLA )  =
    (sem_MultinameInfo_RTQNameLA )
-- semantic domain
type T_MultinameInfo  = ( )
sem_MultinameInfo_Generic :: Word32 ->
                             T_ParamNames  ->
                             T_MultinameInfo 
sem_MultinameInfo_Generic name_ params_  =
    ( )
sem_MultinameInfo_Multiname :: Word32 ->
                               Word32 ->
                               T_MultinameInfo 
sem_MultinameInfo_Multiname name_ set_  =
    ( )
sem_MultinameInfo_MultinameA :: Word32 ->
                                Word32 ->
                                T_MultinameInfo 
sem_MultinameInfo_MultinameA name_ set_  =
    ( )
sem_MultinameInfo_MultinameL :: Word32 ->
                                T_MultinameInfo 
sem_MultinameInfo_MultinameL set_  =
    ( )
sem_MultinameInfo_MultinameLA :: Word32 ->
                                 T_MultinameInfo 
sem_MultinameInfo_MultinameLA set_  =
    ( )
sem_MultinameInfo_QName :: Word32 ->
                           Word32 ->
                           T_MultinameInfo 
sem_MultinameInfo_QName namespace_ name_  =
    ( )
sem_MultinameInfo_QNameA :: Word32 ->
                            Word32 ->
                            T_MultinameInfo 
sem_MultinameInfo_QNameA namespace_ name_  =
    ( )
sem_MultinameInfo_RTQName :: Word32 ->
                             T_MultinameInfo 
sem_MultinameInfo_RTQName name_  =
    ( )
sem_MultinameInfo_RTQNameA :: Word32 ->
                              T_MultinameInfo 
sem_MultinameInfo_RTQNameA name_  =
    ( )
sem_MultinameInfo_RTQNameL :: T_MultinameInfo 
sem_MultinameInfo_RTQNameL  =
    ( )
sem_MultinameInfo_RTQNameLA :: T_MultinameInfo 
sem_MultinameInfo_RTQNameLA  =
    ( )
-- MultinameInfos ----------------------------------------------
-- cata
sem_MultinameInfos :: MultinameInfos  ->
                      T_MultinameInfos 
sem_MultinameInfos list  =
    (Prelude.foldr sem_MultinameInfos_Cons sem_MultinameInfos_Nil (Prelude.map sem_MultinameInfo list) )
-- semantic domain
type T_MultinameInfos  = ( )
sem_MultinameInfos_Cons :: T_MultinameInfo  ->
                           T_MultinameInfos  ->
                           T_MultinameInfos 
sem_MultinameInfos_Cons hd_ tl_  =
    ( )
sem_MultinameInfos_Nil :: T_MultinameInfos 
sem_MultinameInfos_Nil  =
    ( )
-- MultinameKind -----------------------------------------------
-- cata
sem_MultinameKind :: MultinameKind  ->
                     T_MultinameKind 
sem_MultinameKind (MultinameKind_Generic )  =
    (sem_MultinameKind_Generic )
sem_MultinameKind (MultinameKind_Multiname )  =
    (sem_MultinameKind_Multiname )
sem_MultinameKind (MultinameKind_MultinameA )  =
    (sem_MultinameKind_MultinameA )
sem_MultinameKind (MultinameKind_MultinameL )  =
    (sem_MultinameKind_MultinameL )
sem_MultinameKind (MultinameKind_MultinameLA )  =
    (sem_MultinameKind_MultinameLA )
sem_MultinameKind (MultinameKind_QName )  =
    (sem_MultinameKind_QName )
sem_MultinameKind (MultinameKind_QNameA )  =
    (sem_MultinameKind_QNameA )
sem_MultinameKind (MultinameKind_RTQName )  =
    (sem_MultinameKind_RTQName )
sem_MultinameKind (MultinameKind_RTQNameA )  =
    (sem_MultinameKind_RTQNameA )
sem_MultinameKind (MultinameKind_RTQNameL )  =
    (sem_MultinameKind_RTQNameL )
sem_MultinameKind (MultinameKind_RTQNameLA )  =
    (sem_MultinameKind_RTQNameLA )
-- semantic domain
type T_MultinameKind  = ( )
sem_MultinameKind_Generic :: T_MultinameKind 
sem_MultinameKind_Generic  =
    ( )
sem_MultinameKind_Multiname :: T_MultinameKind 
sem_MultinameKind_Multiname  =
    ( )
sem_MultinameKind_MultinameA :: T_MultinameKind 
sem_MultinameKind_MultinameA  =
    ( )
sem_MultinameKind_MultinameL :: T_MultinameKind 
sem_MultinameKind_MultinameL  =
    ( )
sem_MultinameKind_MultinameLA :: T_MultinameKind 
sem_MultinameKind_MultinameLA  =
    ( )
sem_MultinameKind_QName :: T_MultinameKind 
sem_MultinameKind_QName  =
    ( )
sem_MultinameKind_QNameA :: T_MultinameKind 
sem_MultinameKind_QNameA  =
    ( )
sem_MultinameKind_RTQName :: T_MultinameKind 
sem_MultinameKind_RTQName  =
    ( )
sem_MultinameKind_RTQNameA :: T_MultinameKind 
sem_MultinameKind_RTQNameA  =
    ( )
sem_MultinameKind_RTQNameL :: T_MultinameKind 
sem_MultinameKind_RTQNameL  =
    ( )
sem_MultinameKind_RTQNameLA :: T_MultinameKind 
sem_MultinameKind_RTQNameLA  =
    ( )
-- NamespaceInfo -----------------------------------------------
-- cata
sem_NamespaceInfo :: NamespaceInfo  ->
                     T_NamespaceInfo 
sem_NamespaceInfo (NamespaceInfo_Info _kind _name )  =
    (sem_NamespaceInfo_Info (sem_NamespaceKind _kind ) _name )
-- semantic domain
type T_NamespaceInfo  = ( )
sem_NamespaceInfo_Info :: T_NamespaceKind  ->
                          Word32 ->
                          T_NamespaceInfo 
sem_NamespaceInfo_Info kind_ name_  =
    ( )
-- NamespaceInfos ----------------------------------------------
-- cata
sem_NamespaceInfos :: NamespaceInfos  ->
                      T_NamespaceInfos 
sem_NamespaceInfos list  =
    (Prelude.foldr sem_NamespaceInfos_Cons sem_NamespaceInfos_Nil (Prelude.map sem_NamespaceInfo list) )
-- semantic domain
type T_NamespaceInfos  = ( )
sem_NamespaceInfos_Cons :: T_NamespaceInfo  ->
                           T_NamespaceInfos  ->
                           T_NamespaceInfos 
sem_NamespaceInfos_Cons hd_ tl_  =
    ( )
sem_NamespaceInfos_Nil :: T_NamespaceInfos 
sem_NamespaceInfos_Nil  =
    ( )
-- NamespaceKind -----------------------------------------------
-- cata
sem_NamespaceKind :: NamespaceKind  ->
                     T_NamespaceKind 
sem_NamespaceKind (NamespaceKind_Explicit )  =
    (sem_NamespaceKind_Explicit )
sem_NamespaceKind (NamespaceKind_General )  =
    (sem_NamespaceKind_General )
sem_NamespaceKind (NamespaceKind_Internal )  =
    (sem_NamespaceKind_Internal )
sem_NamespaceKind (NamespaceKind_Package )  =
    (sem_NamespaceKind_Package )
sem_NamespaceKind (NamespaceKind_Private )  =
    (sem_NamespaceKind_Private )
sem_NamespaceKind (NamespaceKind_Protected )  =
    (sem_NamespaceKind_Protected )
sem_NamespaceKind (NamespaceKind_Static )  =
    (sem_NamespaceKind_Static )
-- semantic domain
type T_NamespaceKind  = ( )
sem_NamespaceKind_Explicit :: T_NamespaceKind 
sem_NamespaceKind_Explicit  =
    ( )
sem_NamespaceKind_General :: T_NamespaceKind 
sem_NamespaceKind_General  =
    ( )
sem_NamespaceKind_Internal :: T_NamespaceKind 
sem_NamespaceKind_Internal  =
    ( )
sem_NamespaceKind_Package :: T_NamespaceKind 
sem_NamespaceKind_Package  =
    ( )
sem_NamespaceKind_Private :: T_NamespaceKind 
sem_NamespaceKind_Private  =
    ( )
sem_NamespaceKind_Protected :: T_NamespaceKind 
sem_NamespaceKind_Protected  =
    ( )
sem_NamespaceKind_Static :: T_NamespaceKind 
sem_NamespaceKind_Static  =
    ( )
-- NamespaceNames ----------------------------------------------
-- cata
sem_NamespaceNames :: NamespaceNames  ->
                      T_NamespaceNames 
sem_NamespaceNames list  =
    (Prelude.foldr sem_NamespaceNames_Cons sem_NamespaceNames_Nil list )
-- semantic domain
type T_NamespaceNames  = ( )
sem_NamespaceNames_Cons :: Word32 ->
                           T_NamespaceNames  ->
                           T_NamespaceNames 
sem_NamespaceNames_Cons hd_ tl_  =
    ( )
sem_NamespaceNames_Nil :: T_NamespaceNames 
sem_NamespaceNames_Nil  =
    ( )
-- Optional ----------------------------------------------------
-- cata
sem_Optional :: Optional  ->
                T_Optional 
sem_Optional (Optional_Detail _val _kind )  =
    (sem_Optional_Detail _val (sem_ValueKind _kind ) )
-- semantic domain
type T_Optional  = ( )
sem_Optional_Detail :: Word32 ->
                       T_ValueKind  ->
                       T_Optional 
sem_Optional_Detail val_ kind_  =
    ( )
-- Optionals ---------------------------------------------------
-- cata
sem_Optionals :: Optionals  ->
                 T_Optionals 
sem_Optionals list  =
    (Prelude.foldr sem_Optionals_Cons sem_Optionals_Nil (Prelude.map sem_Optional list) )
-- semantic domain
type T_Optionals  = ( )
sem_Optionals_Cons :: T_Optional  ->
                      T_Optionals  ->
                      T_Optionals 
sem_Optionals_Cons hd_ tl_  =
    ( )
sem_Optionals_Nil :: T_Optionals 
sem_Optionals_Nil  =
    ( )
-- ParamNames --------------------------------------------------
-- cata
sem_ParamNames :: ParamNames  ->
                  T_ParamNames 
sem_ParamNames list  =
    (Prelude.foldr sem_ParamNames_Cons sem_ParamNames_Nil list )
-- semantic domain
type T_ParamNames  = ( )
sem_ParamNames_Cons :: Word32 ->
                       T_ParamNames  ->
                       T_ParamNames 
sem_ParamNames_Cons hd_ tl_  =
    ( )
sem_ParamNames_Nil :: T_ParamNames 
sem_ParamNames_Nil  =
    ( )
-- ParamTypes --------------------------------------------------
-- cata
sem_ParamTypes :: ParamTypes  ->
                  T_ParamTypes 
sem_ParamTypes list  =
    (Prelude.foldr sem_ParamTypes_Cons sem_ParamTypes_Nil list )
-- semantic domain
type T_ParamTypes  = ( )
sem_ParamTypes_Cons :: Word32 ->
                       T_ParamTypes  ->
                       T_ParamTypes 
sem_ParamTypes_Cons hd_ tl_  =
    ( )
sem_ParamTypes_Nil :: T_ParamTypes 
sem_ParamTypes_Nil  =
    ( )
-- PoolDoubles -------------------------------------------------
-- cata
sem_PoolDoubles :: PoolDoubles  ->
                   T_PoolDoubles 
sem_PoolDoubles list  =
    (Prelude.foldr sem_PoolDoubles_Cons sem_PoolDoubles_Nil list )
-- semantic domain
type T_PoolDoubles  = ( )
sem_PoolDoubles_Cons :: Double ->
                        T_PoolDoubles  ->
                        T_PoolDoubles 
sem_PoolDoubles_Cons hd_ tl_  =
    ( )
sem_PoolDoubles_Nil :: T_PoolDoubles 
sem_PoolDoubles_Nil  =
    ( )
-- PoolInfo ----------------------------------------------------
-- cata
sem_PoolInfo :: PoolInfo  ->
                T_PoolInfo 
sem_PoolInfo (PoolInfo_Info _integers _uintegers _doubles _strings _namespaces _namesets _multinames )  =
    (sem_PoolInfo_Info (sem_PoolInts _integers ) (sem_PoolUInts _uintegers ) (sem_PoolDoubles _doubles ) (sem_PoolStrings _strings ) (sem_NamespaceInfos _namespaces ) (sem_SetInfos _namesets ) (sem_MultinameInfos _multinames ) )
-- semantic domain
type T_PoolInfo  = ( )
sem_PoolInfo_Info :: T_PoolInts  ->
                     T_PoolUInts  ->
                     T_PoolDoubles  ->
                     T_PoolStrings  ->
                     T_NamespaceInfos  ->
                     T_SetInfos  ->
                     T_MultinameInfos  ->
                     T_PoolInfo 
sem_PoolInfo_Info integers_ uintegers_ doubles_ strings_ namespaces_ namesets_ multinames_  =
    ( )
-- PoolInts ----------------------------------------------------
-- cata
sem_PoolInts :: PoolInts  ->
                T_PoolInts 
sem_PoolInts list  =
    (Prelude.foldr sem_PoolInts_Cons sem_PoolInts_Nil list )
-- semantic domain
type T_PoolInts  = ( )
sem_PoolInts_Cons :: Word32 ->
                     T_PoolInts  ->
                     T_PoolInts 
sem_PoolInts_Cons hd_ tl_  =
    ( )
sem_PoolInts_Nil :: T_PoolInts 
sem_PoolInts_Nil  =
    ( )
-- PoolStrings -------------------------------------------------
-- cata
sem_PoolStrings :: PoolStrings  ->
                   T_PoolStrings 
sem_PoolStrings list  =
    (Prelude.foldr sem_PoolStrings_Cons sem_PoolStrings_Nil list )
-- semantic domain
type T_PoolStrings  = ( )
sem_PoolStrings_Cons :: ByteString ->
                        T_PoolStrings  ->
                        T_PoolStrings 
sem_PoolStrings_Cons hd_ tl_  =
    ( )
sem_PoolStrings_Nil :: T_PoolStrings 
sem_PoolStrings_Nil  =
    ( )
-- PoolUInts ---------------------------------------------------
-- cata
sem_PoolUInts :: PoolUInts  ->
                 T_PoolUInts 
sem_PoolUInts list  =
    (Prelude.foldr sem_PoolUInts_Cons sem_PoolUInts_Nil list )
-- semantic domain
type T_PoolUInts  = ( )
sem_PoolUInts_Cons :: Word32 ->
                      T_PoolUInts  ->
                      T_PoolUInts 
sem_PoolUInts_Cons hd_ tl_  =
    ( )
sem_PoolUInts_Nil :: T_PoolUInts 
sem_PoolUInts_Nil  =
    ( )
-- Rect --------------------------------------------------------
-- cata
sem_Rect :: Rect  ->
            T_Rect 
sem_Rect (Rect_Rect _bits _xMin _xMax _yMin _yMax )  =
    (sem_Rect_Rect _bits _xMin _xMax _yMin _yMax )
-- semantic domain
type T_Rect  = ( )
sem_Rect_Rect :: Int ->
                 Word32 ->
                 Word32 ->
                 Word32 ->
                 Word32 ->
                 T_Rect 
sem_Rect_Rect bits_ xMin_ xMax_ yMin_ yMax_  =
    ( )
-- ScriptInfo --------------------------------------------------
-- cata
sem_ScriptInfo :: ScriptInfo  ->
                  T_ScriptInfo 
sem_ScriptInfo (ScriptInfo_Info _method _traits )  =
    (sem_ScriptInfo_Info _method (sem_Traits _traits ) )
-- semantic domain
type T_ScriptInfo  = ( )
sem_ScriptInfo_Info :: Word32 ->
                       T_Traits  ->
                       T_ScriptInfo 
sem_ScriptInfo_Info method_ traits_  =
    ( )
-- ScriptInfos -------------------------------------------------
-- cata
sem_ScriptInfos :: ScriptInfos  ->
                   T_ScriptInfos 
sem_ScriptInfos list  =
    (Prelude.foldr sem_ScriptInfos_Cons sem_ScriptInfos_Nil (Prelude.map sem_ScriptInfo list) )
-- semantic domain
type T_ScriptInfos  = ( )
sem_ScriptInfos_Cons :: T_ScriptInfo  ->
                        T_ScriptInfos  ->
                        T_ScriptInfos 
sem_ScriptInfos_Cons hd_ tl_  =
    ( )
sem_ScriptInfos_Nil :: T_ScriptInfos 
sem_ScriptInfos_Nil  =
    ( )
-- SetInfo -----------------------------------------------------
-- cata
sem_SetInfo :: SetInfo  ->
               T_SetInfo 
sem_SetInfo (SetInfo_Info _names )  =
    (sem_SetInfo_Info (sem_NamespaceNames _names ) )
-- semantic domain
type T_SetInfo  = ( )
sem_SetInfo_Info :: T_NamespaceNames  ->
                    T_SetInfo 
sem_SetInfo_Info names_  =
    ( )
-- SetInfos ----------------------------------------------------
-- cata
sem_SetInfos :: SetInfos  ->
                T_SetInfos 
sem_SetInfos list  =
    (Prelude.foldr sem_SetInfos_Cons sem_SetInfos_Nil (Prelude.map sem_SetInfo list) )
-- semantic domain
type T_SetInfos  = ( )
sem_SetInfos_Cons :: T_SetInfo  ->
                     T_SetInfos  ->
                     T_SetInfos 
sem_SetInfos_Cons hd_ tl_  =
    ( )
sem_SetInfos_Nil :: T_SetInfos 
sem_SetInfos_Nil  =
    ( )
-- SwfFile -----------------------------------------------------
-- cata
sem_SwfFile :: SwfFile  ->
               T_SwfFile 
sem_SwfFile (SwfFile_File _compressed _version _length _size _rate _count _tags )  =
    (sem_SwfFile_File _compressed _version _length (sem_Rect _size ) _rate _count (sem_Tags _tags ) )
-- semantic domain
type T_SwfFile  = Int ->
                  ( Int,Programs)
data Inh_SwfFile  = Inh_SwfFile {guid_Inh_SwfFile :: !(Int)}
data Syn_SwfFile  = Syn_SwfFile {guid_Syn_SwfFile :: !(Int),programs_Syn_SwfFile :: !(Programs)}
wrap_SwfFile :: T_SwfFile  ->
                Inh_SwfFile  ->
                Syn_SwfFile 
wrap_SwfFile sem (Inh_SwfFile _lhsIguid )  =
    (let ( _lhsOguid,_lhsOprograms) | True = sem _lhsIguid 
     in  (Syn_SwfFile _lhsOguid _lhsOprograms ))
sem_SwfFile_File :: Bool ->
                    Word8 ->
                    Word32 ->
                    T_Rect  ->
                    Word16 ->
                    Word16 ->
                    T_Tags  ->
                    T_SwfFile 
sem_SwfFile_File compressed_ version_ length_ size_ rate_ count_ tags_  =
    (\ _lhsIguid ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 7109 "src/TrfToCFG.hs" #-}
                 )) of
          { _tagsOguid | _tagsOguid `seq` (True) ->
          (case (tags_ _tagsOguid ) of
           { ( _tagsIguid,_tagsIprograms) | True ->
               (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                       _tagsIguid
                       {-# LINE 7116 "src/TrfToCFG.hs" #-}
                       )) of
                { _lhsOguid | _lhsOguid `seq` (True) ->
                (case (({-# LINE 44 "src/TrfToCFG.ag" #-}
                        _tagsIprograms
                        {-# LINE 7121 "src/TrfToCFG.hs" #-}
                        )) of
                 { _lhsOprograms | _lhsOprograms `seq` (True) ->
                 ( _lhsOguid,_lhsOprograms) }) }) }) }))
-- Tag ---------------------------------------------------------
-- cata
sem_Tag :: Tag  ->
           T_Tag 
sem_Tag (Tag_Abc _flags _name _file )  =
    (sem_Tag_Abc (sem_AbcFlags _flags ) _name (sem_AbcFile _file ) )
sem_Tag (Tag_End )  =
    (sem_Tag_End )
sem_Tag (Tag_FileAttributes _useDirectBlit _useGPU _hasMetaData _hasAS3 _useNetwork )  =
    (sem_Tag_FileAttributes _useDirectBlit _useGPU _hasMetaData _hasAS3 _useNetwork )
sem_Tag (Tag_Opaque _kind _length _body )  =
    (sem_Tag_Opaque (sem_TagKind _kind ) _length _body )
-- semantic domain
type T_Tag  = Int ->
              ( Int,Programs)
sem_Tag_Abc :: T_AbcFlags  ->
               ByteString ->
               T_AbcFile  ->
               T_Tag 
sem_Tag_Abc flags_ name_ file_  =
    (\ _lhsIguid ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 7148 "src/TrfToCFG.hs" #-}
                 )) of
          { _fileOguid | _fileOguid `seq` (True) ->
          (case (file_ _fileOguid ) of
           { ( _fileIguid,_fileIprograms) | True ->
               (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                       _fileIguid
                       {-# LINE 7155 "src/TrfToCFG.hs" #-}
                       )) of
                { _lhsOguid | _lhsOguid `seq` (True) ->
                (case (({-# LINE 44 "src/TrfToCFG.ag" #-}
                        _fileIprograms
                        {-# LINE 7160 "src/TrfToCFG.hs" #-}
                        )) of
                 { _lhsOprograms | _lhsOprograms `seq` (True) ->
                 ( _lhsOguid,_lhsOprograms) }) }) }) }))
sem_Tag_End :: T_Tag 
sem_Tag_End  =
    (\ _lhsIguid ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 7169 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 44 "src/TrfToCFG.ag" #-}
                  []
                  {-# LINE 7174 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOprograms | _lhsOprograms `seq` (True) ->
           ( _lhsOguid,_lhsOprograms) }) }))
sem_Tag_FileAttributes :: Bool ->
                          Bool ->
                          Bool ->
                          Bool ->
                          Bool ->
                          T_Tag 
sem_Tag_FileAttributes useDirectBlit_ useGPU_ hasMetaData_ hasAS3_ useNetwork_  =
    (\ _lhsIguid ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 7188 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 44 "src/TrfToCFG.ag" #-}
                  []
                  {-# LINE 7193 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOprograms | _lhsOprograms `seq` (True) ->
           ( _lhsOguid,_lhsOprograms) }) }))
sem_Tag_Opaque :: T_TagKind  ->
                  Word32 ->
                  ByteString ->
                  T_Tag 
sem_Tag_Opaque kind_ length_ body_  =
    (\ _lhsIguid ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 7205 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 44 "src/TrfToCFG.ag" #-}
                  []
                  {-# LINE 7210 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOprograms | _lhsOprograms `seq` (True) ->
           ( _lhsOguid,_lhsOprograms) }) }))
-- TagKind -----------------------------------------------------
-- cata
sem_TagKind :: TagKind  ->
               T_TagKind 
sem_TagKind (TagKind_CSMTextSettings )  =
    (sem_TagKind_CSMTextSettings )
sem_TagKind (TagKind_DefineBinaryData )  =
    (sem_TagKind_DefineBinaryData )
sem_TagKind (TagKind_DefineBits )  =
    (sem_TagKind_DefineBits )
sem_TagKind (TagKind_DefineBitsJPEG2 )  =
    (sem_TagKind_DefineBitsJPEG2 )
sem_TagKind (TagKind_DefineBitsJPEG3 )  =
    (sem_TagKind_DefineBitsJPEG3 )
sem_TagKind (TagKind_DefineBitsJPEG4 )  =
    (sem_TagKind_DefineBitsJPEG4 )
sem_TagKind (TagKind_DefineBitsLossless )  =
    (sem_TagKind_DefineBitsLossless )
sem_TagKind (TagKind_DefineBitsLossless2 )  =
    (sem_TagKind_DefineBitsLossless2 )
sem_TagKind (TagKind_DefineButton )  =
    (sem_TagKind_DefineButton )
sem_TagKind (TagKind_DefineButton2 )  =
    (sem_TagKind_DefineButton2 )
sem_TagKind (TagKind_DefineButtonCxform )  =
    (sem_TagKind_DefineButtonCxform )
sem_TagKind (TagKind_DefineButtonSound )  =
    (sem_TagKind_DefineButtonSound )
sem_TagKind (TagKind_DefineEditText )  =
    (sem_TagKind_DefineEditText )
sem_TagKind (TagKind_DefineFont )  =
    (sem_TagKind_DefineFont )
sem_TagKind (TagKind_DefineFont2 )  =
    (sem_TagKind_DefineFont2 )
sem_TagKind (TagKind_DefineFont3 )  =
    (sem_TagKind_DefineFont3 )
sem_TagKind (TagKind_DefineFont4 )  =
    (sem_TagKind_DefineFont4 )
sem_TagKind (TagKind_DefineFontAlignZones )  =
    (sem_TagKind_DefineFontAlignZones )
sem_TagKind (TagKind_DefineFontInfo )  =
    (sem_TagKind_DefineFontInfo )
sem_TagKind (TagKind_DefineFontInfo2 )  =
    (sem_TagKind_DefineFontInfo2 )
sem_TagKind (TagKind_DefineFontName )  =
    (sem_TagKind_DefineFontName )
sem_TagKind (TagKind_DefineMorphShape )  =
    (sem_TagKind_DefineMorphShape )
sem_TagKind (TagKind_DefineMorphShape2 )  =
    (sem_TagKind_DefineMorphShape2 )
sem_TagKind (TagKind_DefineScalingGrid )  =
    (sem_TagKind_DefineScalingGrid )
sem_TagKind (TagKind_DefineSceneAndFrameLabelData )  =
    (sem_TagKind_DefineSceneAndFrameLabelData )
sem_TagKind (TagKind_DefineShape )  =
    (sem_TagKind_DefineShape )
sem_TagKind (TagKind_DefineShape2 )  =
    (sem_TagKind_DefineShape2 )
sem_TagKind (TagKind_DefineShape3 )  =
    (sem_TagKind_DefineShape3 )
sem_TagKind (TagKind_DefineShape4 )  =
    (sem_TagKind_DefineShape4 )
sem_TagKind (TagKind_DefineSound )  =
    (sem_TagKind_DefineSound )
sem_TagKind (TagKind_DefineSprite )  =
    (sem_TagKind_DefineSprite )
sem_TagKind (TagKind_DefineText )  =
    (sem_TagKind_DefineText )
sem_TagKind (TagKind_DefineText2 )  =
    (sem_TagKind_DefineText2 )
sem_TagKind (TagKind_DefineVideoStream )  =
    (sem_TagKind_DefineVideoStream )
sem_TagKind (TagKind_DoABC )  =
    (sem_TagKind_DoABC )
sem_TagKind (TagKind_DoAction )  =
    (sem_TagKind_DoAction )
sem_TagKind (TagKind_DoInitAction )  =
    (sem_TagKind_DoInitAction )
sem_TagKind (TagKind_EnableDebugger )  =
    (sem_TagKind_EnableDebugger )
sem_TagKind (TagKind_EnableDebugger2 )  =
    (sem_TagKind_EnableDebugger2 )
sem_TagKind (TagKind_End )  =
    (sem_TagKind_End )
sem_TagKind (TagKind_ExportAssets )  =
    (sem_TagKind_ExportAssets )
sem_TagKind (TagKind_FileAttributes )  =
    (sem_TagKind_FileAttributes )
sem_TagKind (TagKind_FrameLabel )  =
    (sem_TagKind_FrameLabel )
sem_TagKind (TagKind_ImportAssets )  =
    (sem_TagKind_ImportAssets )
sem_TagKind (TagKind_ImportAssets2 )  =
    (sem_TagKind_ImportAssets2 )
sem_TagKind (TagKind_JPEGTables )  =
    (sem_TagKind_JPEGTables )
sem_TagKind (TagKind_Metadata )  =
    (sem_TagKind_Metadata )
sem_TagKind (TagKind_Other _code )  =
    (sem_TagKind_Other _code )
sem_TagKind (TagKind_PlaceObject )  =
    (sem_TagKind_PlaceObject )
sem_TagKind (TagKind_PlaceObject2 )  =
    (sem_TagKind_PlaceObject2 )
sem_TagKind (TagKind_PlaceObject3 )  =
    (sem_TagKind_PlaceObject3 )
sem_TagKind (TagKind_Protect )  =
    (sem_TagKind_Protect )
sem_TagKind (TagKind_RemoveObject )  =
    (sem_TagKind_RemoveObject )
sem_TagKind (TagKind_RemoveObject2 )  =
    (sem_TagKind_RemoveObject2 )
sem_TagKind (TagKind_ScriptLimits )  =
    (sem_TagKind_ScriptLimits )
sem_TagKind (TagKind_SetBackgroundColor )  =
    (sem_TagKind_SetBackgroundColor )
sem_TagKind (TagKind_SetTabIndex )  =
    (sem_TagKind_SetTabIndex )
sem_TagKind (TagKind_ShowFrame )  =
    (sem_TagKind_ShowFrame )
sem_TagKind (TagKind_SoundStreamBlock )  =
    (sem_TagKind_SoundStreamBlock )
sem_TagKind (TagKind_SoundStreamHead )  =
    (sem_TagKind_SoundStreamHead )
sem_TagKind (TagKind_SoundStreamHead2 )  =
    (sem_TagKind_SoundStreamHead2 )
sem_TagKind (TagKind_StartSound )  =
    (sem_TagKind_StartSound )
sem_TagKind (TagKind_StartSound2 )  =
    (sem_TagKind_StartSound2 )
sem_TagKind (TagKind_SymbolClass )  =
    (sem_TagKind_SymbolClass )
sem_TagKind (TagKind_VideoFrame )  =
    (sem_TagKind_VideoFrame )
-- semantic domain
type T_TagKind  = ( )
sem_TagKind_CSMTextSettings :: T_TagKind 
sem_TagKind_CSMTextSettings  =
    ( )
sem_TagKind_DefineBinaryData :: T_TagKind 
sem_TagKind_DefineBinaryData  =
    ( )
sem_TagKind_DefineBits :: T_TagKind 
sem_TagKind_DefineBits  =
    ( )
sem_TagKind_DefineBitsJPEG2 :: T_TagKind 
sem_TagKind_DefineBitsJPEG2  =
    ( )
sem_TagKind_DefineBitsJPEG3 :: T_TagKind 
sem_TagKind_DefineBitsJPEG3  =
    ( )
sem_TagKind_DefineBitsJPEG4 :: T_TagKind 
sem_TagKind_DefineBitsJPEG4  =
    ( )
sem_TagKind_DefineBitsLossless :: T_TagKind 
sem_TagKind_DefineBitsLossless  =
    ( )
sem_TagKind_DefineBitsLossless2 :: T_TagKind 
sem_TagKind_DefineBitsLossless2  =
    ( )
sem_TagKind_DefineButton :: T_TagKind 
sem_TagKind_DefineButton  =
    ( )
sem_TagKind_DefineButton2 :: T_TagKind 
sem_TagKind_DefineButton2  =
    ( )
sem_TagKind_DefineButtonCxform :: T_TagKind 
sem_TagKind_DefineButtonCxform  =
    ( )
sem_TagKind_DefineButtonSound :: T_TagKind 
sem_TagKind_DefineButtonSound  =
    ( )
sem_TagKind_DefineEditText :: T_TagKind 
sem_TagKind_DefineEditText  =
    ( )
sem_TagKind_DefineFont :: T_TagKind 
sem_TagKind_DefineFont  =
    ( )
sem_TagKind_DefineFont2 :: T_TagKind 
sem_TagKind_DefineFont2  =
    ( )
sem_TagKind_DefineFont3 :: T_TagKind 
sem_TagKind_DefineFont3  =
    ( )
sem_TagKind_DefineFont4 :: T_TagKind 
sem_TagKind_DefineFont4  =
    ( )
sem_TagKind_DefineFontAlignZones :: T_TagKind 
sem_TagKind_DefineFontAlignZones  =
    ( )
sem_TagKind_DefineFontInfo :: T_TagKind 
sem_TagKind_DefineFontInfo  =
    ( )
sem_TagKind_DefineFontInfo2 :: T_TagKind 
sem_TagKind_DefineFontInfo2  =
    ( )
sem_TagKind_DefineFontName :: T_TagKind 
sem_TagKind_DefineFontName  =
    ( )
sem_TagKind_DefineMorphShape :: T_TagKind 
sem_TagKind_DefineMorphShape  =
    ( )
sem_TagKind_DefineMorphShape2 :: T_TagKind 
sem_TagKind_DefineMorphShape2  =
    ( )
sem_TagKind_DefineScalingGrid :: T_TagKind 
sem_TagKind_DefineScalingGrid  =
    ( )
sem_TagKind_DefineSceneAndFrameLabelData :: T_TagKind 
sem_TagKind_DefineSceneAndFrameLabelData  =
    ( )
sem_TagKind_DefineShape :: T_TagKind 
sem_TagKind_DefineShape  =
    ( )
sem_TagKind_DefineShape2 :: T_TagKind 
sem_TagKind_DefineShape2  =
    ( )
sem_TagKind_DefineShape3 :: T_TagKind 
sem_TagKind_DefineShape3  =
    ( )
sem_TagKind_DefineShape4 :: T_TagKind 
sem_TagKind_DefineShape4  =
    ( )
sem_TagKind_DefineSound :: T_TagKind 
sem_TagKind_DefineSound  =
    ( )
sem_TagKind_DefineSprite :: T_TagKind 
sem_TagKind_DefineSprite  =
    ( )
sem_TagKind_DefineText :: T_TagKind 
sem_TagKind_DefineText  =
    ( )
sem_TagKind_DefineText2 :: T_TagKind 
sem_TagKind_DefineText2  =
    ( )
sem_TagKind_DefineVideoStream :: T_TagKind 
sem_TagKind_DefineVideoStream  =
    ( )
sem_TagKind_DoABC :: T_TagKind 
sem_TagKind_DoABC  =
    ( )
sem_TagKind_DoAction :: T_TagKind 
sem_TagKind_DoAction  =
    ( )
sem_TagKind_DoInitAction :: T_TagKind 
sem_TagKind_DoInitAction  =
    ( )
sem_TagKind_EnableDebugger :: T_TagKind 
sem_TagKind_EnableDebugger  =
    ( )
sem_TagKind_EnableDebugger2 :: T_TagKind 
sem_TagKind_EnableDebugger2  =
    ( )
sem_TagKind_End :: T_TagKind 
sem_TagKind_End  =
    ( )
sem_TagKind_ExportAssets :: T_TagKind 
sem_TagKind_ExportAssets  =
    ( )
sem_TagKind_FileAttributes :: T_TagKind 
sem_TagKind_FileAttributes  =
    ( )
sem_TagKind_FrameLabel :: T_TagKind 
sem_TagKind_FrameLabel  =
    ( )
sem_TagKind_ImportAssets :: T_TagKind 
sem_TagKind_ImportAssets  =
    ( )
sem_TagKind_ImportAssets2 :: T_TagKind 
sem_TagKind_ImportAssets2  =
    ( )
sem_TagKind_JPEGTables :: T_TagKind 
sem_TagKind_JPEGTables  =
    ( )
sem_TagKind_Metadata :: T_TagKind 
sem_TagKind_Metadata  =
    ( )
sem_TagKind_Other :: Word16 ->
                     T_TagKind 
sem_TagKind_Other code_  =
    ( )
sem_TagKind_PlaceObject :: T_TagKind 
sem_TagKind_PlaceObject  =
    ( )
sem_TagKind_PlaceObject2 :: T_TagKind 
sem_TagKind_PlaceObject2  =
    ( )
sem_TagKind_PlaceObject3 :: T_TagKind 
sem_TagKind_PlaceObject3  =
    ( )
sem_TagKind_Protect :: T_TagKind 
sem_TagKind_Protect  =
    ( )
sem_TagKind_RemoveObject :: T_TagKind 
sem_TagKind_RemoveObject  =
    ( )
sem_TagKind_RemoveObject2 :: T_TagKind 
sem_TagKind_RemoveObject2  =
    ( )
sem_TagKind_ScriptLimits :: T_TagKind 
sem_TagKind_ScriptLimits  =
    ( )
sem_TagKind_SetBackgroundColor :: T_TagKind 
sem_TagKind_SetBackgroundColor  =
    ( )
sem_TagKind_SetTabIndex :: T_TagKind 
sem_TagKind_SetTabIndex  =
    ( )
sem_TagKind_ShowFrame :: T_TagKind 
sem_TagKind_ShowFrame  =
    ( )
sem_TagKind_SoundStreamBlock :: T_TagKind 
sem_TagKind_SoundStreamBlock  =
    ( )
sem_TagKind_SoundStreamHead :: T_TagKind 
sem_TagKind_SoundStreamHead  =
    ( )
sem_TagKind_SoundStreamHead2 :: T_TagKind 
sem_TagKind_SoundStreamHead2  =
    ( )
sem_TagKind_StartSound :: T_TagKind 
sem_TagKind_StartSound  =
    ( )
sem_TagKind_StartSound2 :: T_TagKind 
sem_TagKind_StartSound2  =
    ( )
sem_TagKind_SymbolClass :: T_TagKind 
sem_TagKind_SymbolClass  =
    ( )
sem_TagKind_VideoFrame :: T_TagKind 
sem_TagKind_VideoFrame  =
    ( )
-- Tags --------------------------------------------------------
-- cata
sem_Tags :: Tags  ->
            T_Tags 
sem_Tags list  =
    (Prelude.foldr sem_Tags_Cons sem_Tags_Nil (Prelude.map sem_Tag list) )
-- semantic domain
type T_Tags  = Int ->
               ( Int,Programs)
sem_Tags_Cons :: T_Tag  ->
                 T_Tags  ->
                 T_Tags 
sem_Tags_Cons hd_ tl_  =
    (\ _lhsIguid ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 7562 "src/TrfToCFG.hs" #-}
                 )) of
          { _hdOguid | _hdOguid `seq` (True) ->
          (case (hd_ _hdOguid ) of
           { ( _hdIguid,_hdIprograms) | True ->
               (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                       _hdIguid
                       {-# LINE 7569 "src/TrfToCFG.hs" #-}
                       )) of
                { _tlOguid | _tlOguid `seq` (True) ->
                (case (tl_ _tlOguid ) of
                 { ( _tlIguid,_tlIprograms) | True ->
                     (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                             _tlIguid
                             {-# LINE 7576 "src/TrfToCFG.hs" #-}
                             )) of
                      { _lhsOguid | _lhsOguid `seq` (True) ->
                      (case (({-# LINE 44 "src/TrfToCFG.ag" #-}
                              _hdIprograms ++ _tlIprograms
                              {-# LINE 7581 "src/TrfToCFG.hs" #-}
                              )) of
                       { _lhsOprograms | _lhsOprograms `seq` (True) ->
                       ( _lhsOguid,_lhsOprograms) }) }) }) }) }) }))
sem_Tags_Nil :: T_Tags 
sem_Tags_Nil  =
    (\ _lhsIguid ->
         (case (({-# LINE 51 "src/TrfToCFG.ag" #-}
                 _lhsIguid
                 {-# LINE 7590 "src/TrfToCFG.hs" #-}
                 )) of
          { _lhsOguid | _lhsOguid `seq` (True) ->
          (case (({-# LINE 44 "src/TrfToCFG.ag" #-}
                  []
                  {-# LINE 7595 "src/TrfToCFG.hs" #-}
                  )) of
           { _lhsOprograms | _lhsOprograms `seq` (True) ->
           ( _lhsOguid,_lhsOprograms) }) }))
-- Trait -------------------------------------------------------
-- cata
sem_Trait :: Trait  ->
             T_Trait 
sem_Trait (Trait_Trait _name _data _attrs _meta )  =
    (sem_Trait_Trait _name (sem_TraitData _data ) (sem_TraitAttrs _attrs ) (sem_TraitMeta _meta ) )
-- semantic domain
type T_Trait  = ( )
sem_Trait_Trait :: Word32 ->
                   T_TraitData  ->
                   T_TraitAttrs  ->
                   T_TraitMeta  ->
                   T_Trait 
sem_Trait_Trait name_ data_ attrs_ meta_  =
    ( )
-- TraitAttr ---------------------------------------------------
-- cata
sem_TraitAttr :: TraitAttr  ->
                 T_TraitAttr 
sem_TraitAttr (TraitAttr_Final )  =
    (sem_TraitAttr_Final )
sem_TraitAttr (TraitAttr_Metadata )  =
    (sem_TraitAttr_Metadata )
sem_TraitAttr (TraitAttr_Override )  =
    (sem_TraitAttr_Override )
-- semantic domain
type T_TraitAttr  = ( )
sem_TraitAttr_Final :: T_TraitAttr 
sem_TraitAttr_Final  =
    ( )
sem_TraitAttr_Metadata :: T_TraitAttr 
sem_TraitAttr_Metadata  =
    ( )
sem_TraitAttr_Override :: T_TraitAttr 
sem_TraitAttr_Override  =
    ( )
-- TraitAttrs --------------------------------------------------
-- cata
sem_TraitAttrs :: TraitAttrs  ->
                  T_TraitAttrs 
sem_TraitAttrs list  =
    (Prelude.foldr sem_TraitAttrs_Cons sem_TraitAttrs_Nil (Prelude.map sem_TraitAttr list) )
-- semantic domain
type T_TraitAttrs  = ( )
sem_TraitAttrs_Cons :: T_TraitAttr  ->
                       T_TraitAttrs  ->
                       T_TraitAttrs 
sem_TraitAttrs_Cons hd_ tl_  =
    ( )
sem_TraitAttrs_Nil :: T_TraitAttrs 
sem_TraitAttrs_Nil  =
    ( )
-- TraitData ---------------------------------------------------
-- cata
sem_TraitData :: TraitData  ->
                 T_TraitData 
sem_TraitData (TraitData_Class _slotId _class )  =
    (sem_TraitData_Class _slotId _class )
sem_TraitData (TraitData_Const _slotId _tp _vindex _vkind )  =
    (sem_TraitData_Const _slotId _tp _vindex (sem_ValueKind _vkind ) )
sem_TraitData (TraitData_Function _dispId _method )  =
    (sem_TraitData_Function _dispId _method )
sem_TraitData (TraitData_Getter _dispId _method )  =
    (sem_TraitData_Getter _dispId _method )
sem_TraitData (TraitData_Method _dispId _method )  =
    (sem_TraitData_Method _dispId _method )
sem_TraitData (TraitData_Setter _dispId _method )  =
    (sem_TraitData_Setter _dispId _method )
sem_TraitData (TraitData_Slot _slotId _tp _vindex _vkind )  =
    (sem_TraitData_Slot _slotId _tp _vindex (sem_ValueKind _vkind ) )
-- semantic domain
type T_TraitData  = ( )
sem_TraitData_Class :: Word32 ->
                       Word32 ->
                       T_TraitData 
sem_TraitData_Class slotId_ class_  =
    ( )
sem_TraitData_Const :: Word32 ->
                       Word32 ->
                       Word32 ->
                       T_ValueKind  ->
                       T_TraitData 
sem_TraitData_Const slotId_ tp_ vindex_ vkind_  =
    ( )
sem_TraitData_Function :: Word32 ->
                          Word32 ->
                          T_TraitData 
sem_TraitData_Function dispId_ method_  =
    ( )
sem_TraitData_Getter :: Word32 ->
                        Word32 ->
                        T_TraitData 
sem_TraitData_Getter dispId_ method_  =
    ( )
sem_TraitData_Method :: Word32 ->
                        Word32 ->
                        T_TraitData 
sem_TraitData_Method dispId_ method_  =
    ( )
sem_TraitData_Setter :: Word32 ->
                        Word32 ->
                        T_TraitData 
sem_TraitData_Setter dispId_ method_  =
    ( )
sem_TraitData_Slot :: Word32 ->
                      Word32 ->
                      Word32 ->
                      T_ValueKind  ->
                      T_TraitData 
sem_TraitData_Slot slotId_ tp_ vindex_ vkind_  =
    ( )
-- TraitKind ---------------------------------------------------
-- cata
sem_TraitKind :: TraitKind  ->
                 T_TraitKind 
sem_TraitKind (TraitKind_Class )  =
    (sem_TraitKind_Class )
sem_TraitKind (TraitKind_Const )  =
    (sem_TraitKind_Const )
sem_TraitKind (TraitKind_Function )  =
    (sem_TraitKind_Function )
sem_TraitKind (TraitKind_Getter )  =
    (sem_TraitKind_Getter )
sem_TraitKind (TraitKind_Method )  =
    (sem_TraitKind_Method )
sem_TraitKind (TraitKind_Setter )  =
    (sem_TraitKind_Setter )
sem_TraitKind (TraitKind_Slot )  =
    (sem_TraitKind_Slot )
-- semantic domain
type T_TraitKind  = ( )
sem_TraitKind_Class :: T_TraitKind 
sem_TraitKind_Class  =
    ( )
sem_TraitKind_Const :: T_TraitKind 
sem_TraitKind_Const  =
    ( )
sem_TraitKind_Function :: T_TraitKind 
sem_TraitKind_Function  =
    ( )
sem_TraitKind_Getter :: T_TraitKind 
sem_TraitKind_Getter  =
    ( )
sem_TraitKind_Method :: T_TraitKind 
sem_TraitKind_Method  =
    ( )
sem_TraitKind_Setter :: T_TraitKind 
sem_TraitKind_Setter  =
    ( )
sem_TraitKind_Slot :: T_TraitKind 
sem_TraitKind_Slot  =
    ( )
-- TraitMeta ---------------------------------------------------
-- cata
sem_TraitMeta :: TraitMeta  ->
                 T_TraitMeta 
sem_TraitMeta list  =
    (Prelude.foldr sem_TraitMeta_Cons sem_TraitMeta_Nil list )
-- semantic domain
type T_TraitMeta  = ( )
sem_TraitMeta_Cons :: Word32 ->
                      T_TraitMeta  ->
                      T_TraitMeta 
sem_TraitMeta_Cons hd_ tl_  =
    ( )
sem_TraitMeta_Nil :: T_TraitMeta 
sem_TraitMeta_Nil  =
    ( )
-- Traits ------------------------------------------------------
-- cata
sem_Traits :: Traits  ->
              T_Traits 
sem_Traits list  =
    (Prelude.foldr sem_Traits_Cons sem_Traits_Nil (Prelude.map sem_Trait list) )
-- semantic domain
type T_Traits  = ( )
sem_Traits_Cons :: T_Trait  ->
                   T_Traits  ->
                   T_Traits 
sem_Traits_Cons hd_ tl_  =
    ( )
sem_Traits_Nil :: T_Traits 
sem_Traits_Nil  =
    ( )
-- ValueKind ---------------------------------------------------
-- cata
sem_ValueKind :: ValueKind  ->
                 T_ValueKind 
sem_ValueKind (ValueKind_Double )  =
    (sem_ValueKind_Double )
sem_ValueKind (ValueKind_Explicit )  =
    (sem_ValueKind_Explicit )
sem_ValueKind (ValueKind_False )  =
    (sem_ValueKind_False )
sem_ValueKind (ValueKind_Int )  =
    (sem_ValueKind_Int )
sem_ValueKind (ValueKind_Internal )  =
    (sem_ValueKind_Internal )
sem_ValueKind (ValueKind_Namespace )  =
    (sem_ValueKind_Namespace )
sem_ValueKind (ValueKind_Null )  =
    (sem_ValueKind_Null )
sem_ValueKind (ValueKind_Package )  =
    (sem_ValueKind_Package )
sem_ValueKind (ValueKind_Private )  =
    (sem_ValueKind_Private )
sem_ValueKind (ValueKind_Protected )  =
    (sem_ValueKind_Protected )
sem_ValueKind (ValueKind_Static )  =
    (sem_ValueKind_Static )
sem_ValueKind (ValueKind_True )  =
    (sem_ValueKind_True )
sem_ValueKind (ValueKind_UInt )  =
    (sem_ValueKind_UInt )
sem_ValueKind (ValueKind_Undefined )  =
    (sem_ValueKind_Undefined )
sem_ValueKind (ValueKind_Utf8 )  =
    (sem_ValueKind_Utf8 )
-- semantic domain
type T_ValueKind  = ( )
sem_ValueKind_Double :: T_ValueKind 
sem_ValueKind_Double  =
    ( )
sem_ValueKind_Explicit :: T_ValueKind 
sem_ValueKind_Explicit  =
    ( )
sem_ValueKind_False :: T_ValueKind 
sem_ValueKind_False  =
    ( )
sem_ValueKind_Int :: T_ValueKind 
sem_ValueKind_Int  =
    ( )
sem_ValueKind_Internal :: T_ValueKind 
sem_ValueKind_Internal  =
    ( )
sem_ValueKind_Namespace :: T_ValueKind 
sem_ValueKind_Namespace  =
    ( )
sem_ValueKind_Null :: T_ValueKind 
sem_ValueKind_Null  =
    ( )
sem_ValueKind_Package :: T_ValueKind 
sem_ValueKind_Package  =
    ( )
sem_ValueKind_Private :: T_ValueKind 
sem_ValueKind_Private  =
    ( )
sem_ValueKind_Protected :: T_ValueKind 
sem_ValueKind_Protected  =
    ( )
sem_ValueKind_Static :: T_ValueKind 
sem_ValueKind_Static  =
    ( )
sem_ValueKind_True :: T_ValueKind 
sem_ValueKind_True  =
    ( )
sem_ValueKind_UInt :: T_ValueKind 
sem_ValueKind_UInt  =
    ( )
sem_ValueKind_Undefined :: T_ValueKind 
sem_ValueKind_Undefined  =
    ( )
sem_ValueKind_Utf8 :: T_ValueKind 
sem_ValueKind_Utf8  =
    ( )